# DotNet 资源大全中文版 

【导读】：[awesome-dotnet](https://github.com/quozd/awesome-dotnet) 就是 `quozd` 发起维护的 .Net 资源列表，内容包括：编译器、压缩、应用框架、应用模板、加密、数据库、反编译、IDE、日志、风格指南等。

中文版由`开源前哨`和`DotNet`微信公号团队维护更新，欢迎在 Github 上关注。

### 本项目的参与者

- 维护者：`开源前哨`和`DotNet`微信公号团队。 「开源前哨」会定期在知乎专栏分享最新、有趣和热门的开源项目，每个项目都有详细的介绍和示例。传送门：<https://www.zhihu.com/column/c_1317124962785062912>

- 贡献者：[Monga](https://github.com/lgengy)、[cccookieee](https://github.com/cccookieee)、JingerJoe、云中游、冰斌、Juliesand、[ZZMarquis](https://github.com/ZZMarquis)、[颜闽辉](https://github.com/yanminhui/)、[tangyouhua](https://github.com/tangyouhua)

注：名单不分排名，不定期补充更新



# 资源列表

* [Awesome DotNet](#awesome-dotnet)
  * [算法与数据结构(Algorithms and Data Structures)](#算法与数据结构)
  * [API](#api)
  * [应用框架(Application Frameworks)](#应用框架)
  * [应用模板(Application Templates)](#应用模板)
  * [人工智能(Artificial Intelligence)](#人工智能)
  * [程序集处理(Assembly Manipulation)](#程序集处理)
  * [资产(Assets)](#资产)
  * [认证和授权(Authentication and Authorization)](#认证和授权)
  * [书籍(Books)](#书籍)
  * [自动构建(Build Automation)](#自动构建)
  * [智能业务与报表(Business Intelligence and Reporting)](#智能业务与报表)
  * [缓存(Caching)](#缓存)
  * [日历(Calendar)](#日历)
  * [CLI](#cli)
  * [CLR](#clr)
  * [CMS](#cms)
  * [代码分析和度量(Code Analysis and Metrics)](#代码分析和度量)
  * [代码片段(Code Snippets)](#代码片段)
  * [编译器、透明机和语言(Compilers, Transpilers and Languages)](#编译器、透明机和语言)
  * [压缩(Compression)](#压缩)
  * [持续集成(Continuous Integration)](#持续集成)
  * [加密(Cryptography)](#加密)
  * [数据库(Database)](#数据库)
  * [数据库驱动(Database Drivers)](#数据库驱动)
  * [日期(DateTime)](#日期)
  * [反编译(Decompilation)](#反编译)
  * [部署(Deployment)](#部署)
  * [DirectX](#directx)
  * [分布式计算(Distributed Computing)](#分布式计算)
  * [DLR](#dlr)
  * [文档(Documentation)](#文档)
  * [电子商务和支付(E-Commerce and Payments)](#电子商务和支付)
  * [环境管理(Environment Management)](#环境管理)
  * [ETL](#etl)
  * [时间聚合器和发送器(Event aggregator and messenger)](#时间聚合器和发送器)
  * [异常(Exceptions)](#异常)
  * [扩展库(Extensions librairies)](#扩展库)
  * [函数式编程(Functional programming)](#函数式编程)
  * [游戏(Game)](#游戏)
  * [GIS](#gis)
  * [Git工具](#Git工具)
  * [图形(Graphics)](#图形)
  * [GUI](#gui)
  * [HTML and CSS](#html-and-css)
  * [HTTP](#http)
  * [IDE](#ide)
  * [图像处理(Image Processing)](#图像处理)
  * [安装工具(Install Tools)](#安装工具)
  * [国际化(Internationalization)](#国际化)
  * [互操作(Interoperability)](#互操作)
  * [IoC](#ioc)
  * [JavaScript引擎](#Javascript引擎)
  * [日志(Logging)](#日志)
  * [邮件(Mail)](#邮件)
  * [机器学习和数据科学(Machine Learning and Data Science)](#机器学习和数据科学)
  * [Markdown处理器](#Markdown处理器)
  * [数学(Mathematics)](#数学)
  * [媒体(Media)](#媒体)
  * [度量(Metrics)](#度量)
  * [微框架(Micro Framework)](#微框架)
  * [缩率(Minification)](#缩率)
  * [杂项(Misc)](#杂项)
  * [MVVM](#MVVM)
  * [对象到对象映射(Object to object mapping)](#对象到对象映射)
  * [Office](#Office)
  * [ORM](#ORM)
  * [包管理(Package Management)](#包管理)
  * [PDF](#pdf)
  * [分析器(Profiler)](#分析器)
  * [协议(Protocols)](#协议)
  * [推送通知(Push Notifications)](#推送通知)
  * [查询构造器(Query Builders)](#查询构造器)
  * [队列(Queue)](#队列)
  * [反应式编程(Reactive Programming)](#反应式编程)
  * [实时通信(Real-time Communications)](#实时通信)
  * [计划调度(Scheduling)](#计划调度)
  * [SDK和API客户端](#SDK和API客户端)
  * [搜索(Search)](#搜索)
  * [序列化(Serialization)](#序列化)
  * [短信和电话(SMS and Phone Calls)](#短信和电话)
  * [状态机(State machines)](#状态机)
  * [静态网站生成(Static Site Generators)](#静态网站生成)
  * [强命名(Strong Naming)](#强命名)
  * [风格指南(Style Guide)](#风格指南)
  * [模板引擎(Template Engine)](#模板引擎)
  * [测试(Testing)](#测试)
  * [工具(Tools)](#工具)
  * [交易(Trading)](#交易)
  * [UI自动化](#ui自动化)
  * [Visual Studio 插件](#visual-studio-插件)
  * [Web浏览器](#Web浏览器)
  * [Web框架](#Web框架)
  * [Web服务器](#Web服务器)
  * [WebSocket](#websocket)
  * [Windows服务](#Windows服务)
  * [WPF](#wpf)
  * [解析器库(Parser Library)](#解析器库)
* [其他列表](#其他列表)
* [资源](#资源)

## 算法与数据结构

* [Algorithmia](https://github.com/SolutionsDesign/Algorithmia) -  用于.NET 3.5及以上的算法与数据结构库。算法包含复杂高级的算法，数据结构有图、优先队列、command和undo-redo等.
* [C# Algorithms](https://github.com/aalhour/C-Sharp-Algorithms) - 标准数据结构与算法的C#即插即用类库项目，包含35+数据结构和以面向对象独立组件形式设计的30+算法。
* [Towel](https://github.com/ZacharyPatten/Towel) - 数据结构，算法，数学，元数据(metadata)，扩展，终端，度量(measurements)和其它有用的东西。

## API

* [Telegram.Bot](https://github.com/TelegramBots/Telegram.Bot) - 用于[Telegram Bot API](https://core.telegram.org/bots/api)的.NET客户端。
* [TLSharp](https://github.com/sochix/TLSharp) - 能够完美适配那些想要把数据直接发送给Telegram用户或编写自定义Telegram客户端的开发者。
* [NancyFx](https://github.com/NancyFx/Nancy) - 轻量、用于构建 HTTP 基础服务的非正式(low-ceremony)框架，基于.Net及Mono 平台。
* [ASP.NET Web API](https://dotnet.microsoft.com/apps/aspnet/apis) - 快捷创建HTTP服务的框架，可以广泛用于多种不同的客户端，包括浏览器和移动设备。
* [Breeze](https://breeze.github.io/doc-net/) - 通过使用OData 3协议赋能API框架丰富的数据访问。客户端库能用于JavaScript和C#.
* [Mobius: C# API for Spark](https://github.com/Microsoft/Mobius) - Mobius把C#绑定到Apache Spark，之后便可通过C#操作Spark驱动实现的代码与数据处理。
* [ServiceStack](https://github.com/ServiceStack/ServiceStack) - 巧妙的架构, 以及足够快的速度，为所有人提供尽情享受的web服务。
* [Nelibur](https://github.com/Nelibur/Nelibur) - Nelibur是一个使用纯WCF构建的基于消息的web服务框架。Nelibur可以便捷地创建高性能、基于消息的web服务，保证你能够使用WCF的的所有强大功能。
* [WebAPI Contrib](https://github.com/WebApiContrib/WebAPIContrib) - 帮助你提升ASP.NET Web API能力的开源项目库。
* [Xamarin.Essentials](https://docs.microsoft.com/en-us/xamarin/essentials/) - Xamarin.Essentials为开发者的移动应用提供跨平台的API.
* [FFImageLoading - Fast & Furious Image Loading](https://github.com/luberda-molinet/FFImageLoading) - 这个库能够在Xamarin.iOS, Xamarin.Android, Xamarin.Forms, Xamarin.Mac/Xamarin.Tizen和Windows(UWP, WinRT)上简单且快速的加载图片。
* [Ocelot](https://github.com/ThreeMammals/Ocelot) - .NET core API 起步。
* [CommandQuery](https://github.com/hlaueriksson/CommandQuery) - 用于ASP.NET Web API 2, ASP.NET Core, AWS Lambda和Azure函数的命令查询分离(Command Query Separation)。

## 应用框架

* [.NET Boxed Framework](https://github.com/Dotnet-Boxed/Framework) - .NET Core 扩展与帮助NuGet包。
* [ASP.NET Boilerplate](https://github.com/aspnetboilerplate/aspnetboilerplate) - 现代ASP.NET MVC web应用程序的入门，包含最佳实践和最流行的工具。
* [ABP](https://github.com/abpframework/abp) - 下一代 ASP.NET Boilerplate web 应用框架。
* [Butterfly Server .NET](https://butterflyserver.io) - 使定义的 Web API 和 Subscription API 能够在已连接的各个客户端间自动同步数据集，在最低花销下创建实时web应用和本地应用。
* [Orleans](https://github.com/dotnet/orleans) - Orleans框架提供了直接构建分布式、大规模计算应用的方法，无需学习和使用复杂的并行或扩展模型。
* [Newbe.Claptrap](https://github.com/newbe36524/Newbe.Claptrap) - 这是一个有着反应式、事件溯源和演员模式作为基本原理的服务端开发框架集。最重要的是，开发人员可以更简单的开发出“分布式”、“横向扩展”和“易测试”的应用。
* [CoreFX](https://github.com/dotnet/corefx) -  corefx 仓包含对 .NET Core 的库实现(叫做“CoreFX”)。它包含 System.Collections, System.IO, System.Xml 和许多其它组件。
* [CSLA .NET](https://github.com/MarimerLLC/csla) - 业务层开发框架https://cslanet.com/。
* [Mono](https://github.com/mono/mono) - 开源ECMA CLI, C#, F#, VB and .NET的实现。
* [Mono-Addins](https://github.com/mono/mono-addins) - Mono.Addins 是一个通用框架，用于创建可扩展的应用程序，以及这些应用程序的扩展插件。
* [peasy](https://github.com/peasy/Peasy.NET) - Peasy 是一个中间层框架用于提供易于使用的和灵活的规则引擎，旨在解决诸如并发处理、事务支持、容错、多线程、扩展性、异步和多客户端支持等常见问题，并且易于测试，学习难度也不大。
* [Spring.Net](https://github.com/spring-projects/spring-net) - Spring.NET是一个开源的应用程序框架，可以便捷地创建企业级 .NET 项目。
* [DotNetty](https://github.com/Azure/DotNetty) - DotNetty 是 Netty 的端口, 异步事件驱动的网络应用框架，用于快速开发可维护的高性能协议服务与客户端。
* [AspectCore Framework](https://github.com/dotnetcore/AspectCore-Framework) - AspectCore Framework 是用于.NET Core and .NET Framework的基于面向切面编程的跨平台框架，对切面拦截器、依赖项注入集成、web应用、数据验证等提供核心支持。
* [HopFramework](https://github.com/DiegoTondim/hop-framework) - HopFramework 是一个轻松创建项目的框架，使用领域驱动设计和许多模式来交付更好的解决方案。

## 应用模板

* [.NET Boxed Templates](https://github.com/Dotnet-Boxed/Templates) - 开箱即用的.NET 项目模板，用最少的代码做更快的开发。
* [ASP.NET Core Starter Kit](https://github.com/kriasoft/aspnet-starter-kit) - 后端: .NET Core, EF Core, C#; 前端: Babel, Webpack, React, CSS模块
* [MVC.Template](https://github.com/NonFactors/AspNetCore.Template) - ASP.NET Core MVC 项目入门模板。
* [ProjectScaffold](https://github.com/fsprojects/ProjectScaffold) - F# 基金会推荐的 .NET 解决方案的原型——包括文件系统的搭建、用于管理依赖的 Paket 以及用于自动化构建、测试的 FAKE。默认情况下，构建流程也会对文档进行编译，并生成 NuGet 程序包。
* [Serene](https://github.com/volkanceylan/Serenity) - Serenity 是一种 ASP.NET MVC 应用平台，其架构是基于服务的，旨在简化和缩短以数据为中心的业务应用程序开发。同时，Serene是构建Serenity应用的起步模板。
* [Side-Waffle](https://github.com/LigerShark/side-waffle) - 包含大量有用的Web和桌面开发模板。
* [Template10](https://github.com/Windows-XAML/Template10) - 带有设计模式的 Windows 10 模板。
* [Nucleus](https://github.com/alirizaadiyahsi/Nucleus) - Vue 起步应用模板，后端使用 ASP.NET Core API 分层体系结构和基于JWT的认证。
* [JHipster.NET](https://github.com/jhipster/jhipster-dotnetcore) JHipster 的愿景是用 asp.net core 替换原先的SpringBoot后端。jhipster的主要目标是展示java中现代web开发最佳实践，因此.Net中项目的目标也是一样的。前端可以使用angular或react，不久后还能使用blazor。

## 人工智能
* [AIMLBot (Program#)](http://aimlbot.sourceforge.net/) - 使用C#编写的基于AIML(人工智能标记语言)的小型、快速、兼容标准、易于定制的聊天机器人，。
* [SIML](https://simlbot.com/) - 人造智能标记语言(Synthetic Intelligence Markup Language)，下一代聊天机器人及数字助手语言。

## 程序集处理

* [Fody](https://github.com/Fody/Fody) - 组合.Net程序集的可扩展工具。
* [ILRepack](https://github.com/gluck/il-repack) - ILMerge的开源替代。
* [Mono.Cecil](https://github.com/jbevain/cecil) - Cecil是 ECMA CIL 中生成和检查程序与库的库。

## 资产

* [Cassette](https://github.com/andrewdavey/cassette) - 管理 .NET web 应用资产(脚本、css和模板)。
* [NodeAssets](https://github.com/ajorkowski/NodeAssets) - .NET资产管理器，可以使用SignalR或NodeJS编译器实时更新css。
* [Bundle Transformer](https://github.com/Taritsyn/BundleTransformer) - 对[Microsoft ASP.NET Web Optimization Framework](https://www.nuget.org/packages/Microsoft.AspNet.Web.Optimization)的模块化扩展。 其模块支持 LESS, Sass, CoffeeScript, TypeScript, Mustache, Handlebars, Autoprefixer 以及许多不同的JS和CSS简化程序。
* [Bundler](https://github.com/ServiceStack/Bundler) - 编译并最小化 Less/Sass/Stylus/Css/JS/CoffeeScript/LiveScript 文件，集成MVC和ServiceStack。
* [SquishIt](https://github.com/jetheredge/SquishIt) - *轻松*绑定一些CSS和JavaScript

## 认证和授权

* [ASP.NET Identity](https://github.com/aspnet/Identity/) - 用于ASP.NET应用的新身份系统。
* [ASP.NET SAML](https://github.com/jitbit/AspNetSaml) - 对ASP.NET app的SAML认证支持。
* [DotNetOpenAuth](https://github.com/DotNetOpenAuth/DotNetOpenAuth) - OpenID、OAuth和InfoCard协议的C#实现。
* [Logibit Hawk](https://github.com/logibit/logibit.hawk/) - F# [Hawk](https://github.com/outmoded/hawk)认证库。
* [IdentityModel](https://github.com/IdentityModel) - .NET 4.5 和 MVC4、Web API 身份和访问控制的辅助库。
* [IdentityServer](https://github.com/IdentityServer) - 可扩展的 OAuth2 和 OpenID Connect 供应商框架。
* [OAuth](https://github.com/danielcrenna/vault/tree/master/oauth) - C#编写的用于生成 OAuth 1.0a 签名的超轻量级库。
* [Stuntman](https://rimdev.io/stuntman/) - Stuntman 是一个在开发期间利用.Net声明标识来模拟用户的库。

## 区块链

* [Nethermind](https://github.com/NethermindEth/nethermind) - .NET Core中完整的Ethereum客户端。

## 书籍

* [.NET Core in Action](https://www.manning.com/books/dotnet-core-in-action) - 使用.NET Core开发应用与库教程。 **[$]**
* C# in Depth - [3rd edition](https://www.manning.com/books/c-sharp-in-depth-third-edition), [4th edition (early access)](https://www.manning.com/books/c-sharp-in-depth-fourth-edition) - 深度剖析C#。 **[$]**
* [CLR via C#](https://www.microsoftpressstore.com/store/clr-via-c-sharp-9780735667457) - 深入挖掘并掌握C#和.Net开发中公共语言运行时的复杂性。 **[$]**
* [Functional Programming in C#](https://www.manning.com/books/functional-programming-in-c-sharp) - C#函数式编程特性最佳利用教程。 **[$]**
* [Microservices in .NET Core](https://www.manning.com/books/microservices-in-net-core-second-edition) - 使用.NET栈构建微服务系统的综合指南。 **[$]**
* [Dependency Injection in .NET](https://www.manning.com/books/dependency-injection-principles-practices-patterns) [2nd edition](https://www.manning.com/books/dependency-injection-principles-practices-patterns) - 教你怎样在.NET中使用依赖注入来减少应用组件间的硬编码依赖。 **[$]**
* [ASP.NET Core in Action](https://www.manning.com/books/asp-net-core-in-action) - ASP.NET Core web 应用开发教程。 **[$]**
* [Entity Framework Core in Action](https://www.manning.com/books/entity-framework-core-in-action) - 教你怎样使用 Entity Framework Core，包括轻量级的数据访问替代，如Dapper。 **[$]**
* [The Little ASP.NET Core Book](https://recaffeinate.co/book/) - 免费、开源、入门级的书籍，旨在提供对ASP.NET Core的简单介绍。

## 自动构建

* [Psake](https://github.com/psake/psake) - 使用PowerShell开发的基于.NET的自动化构建工具。
* [FAKE](https://github.com/fsharp/FAKE) - 即F# Make，跨平台自动构建系统。
* [Invoke-Build](https://github.com/nightroman/Invoke-Build) - 受Psake的启发，PowerShell自动化构建与测试工具。
* [MSBuild](https://github.com/dotnet/msbuild) - 微软构建引擎(Microsoft Build Engine)是.NET和 Visual Studio 的构建平台。
* [Cake](https://github.com/cake-build/cake) - 即 C# Make，使用 C# DSL 的跨平台自动构建系统。
* [Nake](https://github.com/yevhen/Nake) - 神奇的基于脚本的 C# task runner。
* [Nuke](https://github.com/nuke-build/nuke) - 跨平台自动化构建系统。
* [FlubuCore](https://github.com/dotnetcore/FlubuCore) -  跨平台的自动化构建与部署系统，C#中用其创建项目与执行部署脚本。

## 智能业务与报表

* [FastReport](https://github.com/FastReports/FastReport) - .NET Core 2.x/.Net Framework 4.x的开源报表生成器，能够用在 ASP.NET MVC、 Web API 应用中。
* [NReco PivotData](https://www.nrecosite.com/pivot_data_library_net.aspx) - 内存数据aggregation/OLAP库，数据透视表生成(渲染HTML, 导出), ASP.NET 数据透视生成器工具 **[$][对个人开发者及非软件服务提供商(non-SaaS)免费]**

## 缓存

* [CacheCow](https://github.com/aliostad/CacheCow) - ASP.NET Web API HTTP 客户端和服务器端缓存实现。
* [Akavache](https://github.com/reactiveui/Akavache) - 异步、持久化的键值存储。
* [EasyCaching](https://github.com/dotnetcore/EasyCaching) - 缓存库，包含缓存的基本用法和一些高级用法，可以使缓存处理更容易。
* [CacheManager](https://github.com/MichaCo/CacheManager) - 用于缓存的通用接口与抽象层。
* [Foundatio](https://github.com/FoundatioFx/Foundatio#caching) - 内存、Redis和hybrid实现的通用接口。
* [Cashew](https://github.com/joakimskoog/Cashew) - 一个简单、优雅且强大的.NET库，用于通过API使`HttpClient`轻松进行缓存响应。

## 日历

* [iCal.NET](https://github.com/rianjs/ical.net) iCal.NET 是一个用于.NET的iCalendar(RFC 5545)类库，旨在提供RFC 5545合规性，同时完全兼容常用的日历应用和库。

## CLI

* [Appccelerate - Command Line Parser](https://www.appccelerate.com/commandlineparser.html) - 由流畅的语法定义、不同参数类型、必填和可选参数、值约束、别名、类型转换和半自动帮助信息组成的命令行解析器。
* [Argu](https://github.com/fsprojects/Argu) - F# 应用的声明式CLI参数与 & XML 配置解析器。
* [CliFx](https://github.com/Tyrrrz/CliFx) - 构建命令行接口的声明式框架。
* [clipr](https://github.com/nemec/clipr) - 一个受Python参数解析(argparse)启发的CLI库，把命令行转换成强类型对象。提供自定义参数类型，自动化（和本地化）的帮助生成，以及用多种方式存储被解析的参数。
* [CliWrap](https://github.com/Tyrrrz/CliWrap) - 包装命令行接口。
* [Colorful.Console](https://github.com/tomakita/Colorful.Console) - 彩色的控制台输出。
* [CommandDotNet](https://github.com/bilal-fazlani/commanddotnet) - 使用C#以可组合的方式模块化你的控制台应用。用方法定义命令，用属性或嵌套类定义定义子命令。解析与命令的执行是可扩展的。   
* [Command Line Parser](https://github.com/commandlineparser/commandline) - Command Line Parser 库为CLR应用程序提供了一套简洁的API，用于处理命令行参数及相关任务。
* [CsConsoleFormat](https://github.com/Athari/CsConsoleFormat) - 用于控制台高级格式化输出的 .NET C# 库。
* [Docopt](https://github.com/docopt/docopt.net) - 好用到不行的命令行接口描述语言。
* [EntryPoint](https://github.com/Nick-Lucas/EntryPoint) - 用于.NET Core 与 .NET Framework 4.5+ 的可组合的CLI参数解析器。
* [Fluent Command Line Parser](https://github.com/fclp/fluent-command-line-parser) - 简单、强类型的 .NET C# 命令行解析库，交互方式流畅易用。
* [JustCli](https://github.com/jden123/JustCli) - 快速创建你自己命令行工具的方法。
* [Gui.cs](https://github.com/migueldeicaza/gui.cs) - .NET终端UI工具套件。
* [Power Args](https://github.com/adamabdelhamed/PowerArgs) - PowerArgs 将命令行参数转换为.NET对象，便于程序使用。它还提供了大量可选的扩展，例如参数校验、自动生成使用帮助、tab补全等等。
* [ReadLine](https://github.com/tonerdo/readline) - 用于.NET/.NET Core的类似GNU-Readline的库。
* [RunInfoBuilder](https://github.com/rushfive/RunInfoBuilder) - 独特的命令行解析器，用于命令的对象树。
* [SharpNetSH](https://github.com/rpetz/SharpNetSH) - 用于C#的简单netsh库。
* [spectre.console](https://github.com/spectresystems/spectre.console) - 一个使创建美丽的控制台应用更简单的库。

## CLR

* [Runtime](https://github.com/dotnet/runtime) - runtime仓包含了完整的.NET Core运行时实现（又叫做"CoreCLR"）。其包括RyuJIT、.NET GC、本地交互操作和许多其它组件。

## CMS

* [Composite C1](https://github.com/Orckestra/C1-CMS-Foundation) - 一个web内容管理系统，着重在用户体验及适应性。
* [mojoPortal ](https://github.com/i7media/mojoportal) - MojoPortal 是一个使用 C# ASP.NET 开发的可扩展、跨数据库、移动友好的web内容管理系统（CMS）和 web 应用程序框架。
* [N2CMS](https://github.com/n2cms/n2cms) - 开源、轻量、代码优先的CMS，可以无缝地集成到任何MVC项目中。
* [Orchard ](https://github.com/OrchardCMS/Orchard) - 免费、开源、专注社区的项目，目标是在 ASP.NET 平台上提供应用程序和可重用组件。
* [Piranha CMS](https://github.com/PiranhaCMS/Piranha) - Piranha 是一个有趣、快速、轻量级的.NET框架，用于开发基于cms附带其它功能的web应用程序。它基于 ASP.NET MVC 和Web页面创建，完全兼容 Visual Studio 和 WebMatrix。https://piranhacms.org
* [Umbraco](https://github.com/umbraco/Umbraco-CMS) - Umbraco 是一个基于 ASP.NET 平台构建的免费开源内容管理系统。
* [BetterCMS](http://www.bettercms.com) - 用于开发人员与发布人员的开源.NET 直观用户界面。
* [DotNetNuke](https://www.dnnsoftware.com/community/download) - DNN 平台是我们免费、开源的 web CMS 以及每一个专业DNN解决方案的基础。世界范围内超过750,000家组织由DNN平台提供网站支持。
* [BlogEngine.NET](https://github.com/rxtur/BlogEngine.NET) - 简单但是功能齐备的ASP.NET博客。

## 代码分析和度量

* [.NET Compiler Platform ("Roslyn") Analyzers](https://github.com/dotnet/roslyn-analyzers) - 许多初级阶段的Roslyn诊断分析器，以帮助充实静态分析API的设计与实现。
* [NDepend](https://www.ndepend.com) - Visual Studio 和 VS 团队服务扩展，可以评估你的.NET代码质量和技术债务，用C# LINQ 语法创建代码规则，使代码结构可视化，关注变化与演进。**[$]**
* [App.Metrics](https://github.com/AppMetrics/AppMetrics) - App Metrics 是一个用于应用内部记录、度量报告和健康报告的开源、跨平台库。详见[docs](https://www.app-metrics.io/)。 
* [CodeMaid](http://www.codemaid.net/) - Visual studio 扩展，用于清理、挖掘和简化C#、C++、F#、VB、PHP、JSON、XAML、XML、ASP、HTML、CSS、LESS、SCSS、JavaScript 和 TypeScript 代码。
* [StyleCop](https://github.com/StyleCop) - StyleCop 分析C#源码以强化一组样式和一致性规则。
* [Gendarme](https://github.com/spouliot/gendarme) - 可扩展的、基于规则的工具，用于在.NET应用和库中查找问题。
* [Metrics-Net](https://github.com/Recognos/Metrics.NET) - 捕获CLR应用级度量，以便知道接下来将会发生什么。
* [AspNet.Metrics](https://github.com/alhardy/aspnet-metrics) - 捕获CLR、应用级web请求度量，中间件及扩展使用Metrics-Net。
* [BenchmarkDotNet](https://github.com/dotnet/BenchmarkDotNet) - 基准化分析方法(benchmarking)强大的.NET 库。
* [Codinion](https://www.codinion.com/) - C#和一些其它的"Visual"功能加强语法高亮。**[$]**
* [NsDepCop](https://github.com/realvizu/NsDepCop) - C#项目中用于强化命名空间依赖规则的静态代码分析工具。

## 代码片段

* [.NET Fiddle](https://dotnetfiddle.net/) - 在浏览器中开发、编译及运行C#、F#和VB ，JSFiddle相当于.Net。
* [Gistlyn](https://gistlyn.com/) - 创建、运行和分享你的可执行 C# GitHub 要点。
* [Sharplab](https://sharplab.io/) - 使用Roslyn不同的分支和版本来运行C#代码，查看IL生成的内容和检查JIT输出。

## 编译器、透明机和语言

* [Bridge.NET](https://github.com/bridgedotnet/Bridge) - 将C#编译成JavaScript的开源编译器https://bridge.net/。
* [ClojureCLR](https://github.com/clojure/clojure-clr) - Clojure到CLR的端口，Clojure项目的一部分。
* [F#](https://github.com/fsharp/fsharp/) -  F#编译器、核心库和工具——更安全、更快、代码更好的函数式编程语言。
* [Hybridizer](https://www.altimesh.com/hybridizer-essentials/) - CIL (C#, VB.Net, F#) 至 CUDA 编译器。**[$]**
* [IronScheme](https://github.com/IronScheme/IronScheme) - R6RS结构编译器、运行时和许多标准库。
* [JSIL](https://github.com/sq/JSIL) - CIL至JavaScript编译器http://jsil.org/。
* [Mond](https://github.com/Rohansi/Mond) - C#写的有着REPL、调试器和简单嵌入式API的动态类型脚本语言。
* [Mono-basic](https://github.com/mono/mono-basic) - Visual Basic 编译器和运行时。
* [Nemerle](https://github.com/rsdn/nemerle) - Nemerle 是用于.NET平台的高阶静态类型编程语言。提供函数式的、面向对象的和迫切的功能。有着简单的类C#语法和强大的元编程系统。
* [Netjs](https://github.com/praeclarum/Netjs) - .NET至TypeScript和JavaScript编译器，可移植类库在这方面有着良好的效果，甚至可以传递EXE。
* [P](https://github.com/p-org/P) - P 是用于异步事件驱动的编程语言。
* [PeachPie](https://github.com/peachpiecompiler/peachpie) - PeachPie是一个用于.NET和.NET Core的PHP编译器和运行时，让整个PHP应用跑在现代、安全和高性能的.NET与.NET Core平台上。
* [Roslyn](https://github.com/dotnet/roslyn) - .NET编译平台（“Roslyn”）提供开源的 C# 和 Visual Basic 编译器，包含丰富的代码分析 API，可以使用像 Visual Studio 一样的API来构建代码分析工具。
* [Testura.Code](https://github.com/Testura/Testura.Code) - 围绕着Roslyn API的编译器，用于生成、保存和编译C#代码，提供方法与帮助来生成类、方法、状态和表达式。
* [VisualFSharp](https://github.com/dotnet/fsharp) - Visual F# 编译器和工具。
* [Fable](https://github.com/fable-compiler/Fable) - F#至JavaScript编译器。
* [LinqOptimizer](https://github.com/nessos/LinqOptimizer) - 自动查询优化器，用于顺序和并行LINQ编译器。
* [Roslyn-linq-rewrite](https://github.com/antiufo/roslyn-linq-rewrite) - 通过先重写LINQ表达式的语法树，以便使用简单的程序码编译C#代码，做到配置与动态分配最小化。
* [Iron python](https://github.com/IronLanguages/ironpython2) - 集成到 dot net 的 python 2 实现。
* [Amplifier.NET](https://github.com/tech-quantum/Amplifier.NET) - 使用C#开发和编译你自己的内核功能，Amplifier 会小心的在你最喜欢的硬件上运行它。Amplifier 可以让.NET开发者在Intel CPU/GPU, NVIDIA, AMD上轻松的运行有着密集数学运算的复杂应用而不用开发额外的 C 内核代码。

## 压缩

* [SharpCompress](https://github.com/adamhathcock/sharpcompress) - SharpCompress 是一个用于 .NET、Mono、Silverlight、WP7 的压缩库，可以解压rar、7zip、zip、tar、bzip2 和 gzip，提供只读和随机文件访问API。支持对zip/tar/bzip2/gzip进行写入的实现。
* [DotNetZip.Semverd](https://github.com/haf/DotNetZip.Semverd) - 一个开源项目，提供对ZIP文件处理的.NET库和相关工具。([**Unmaintained** DotNetZip](https://archive.codeplex.com/?p=dotnetzip)的一个fork)
* [SharpZipLib](https://icsharpcode.github.io/SharpZipLib/) - 一个 Zip、GZip、Tar 和 BZip2 的库，完全由C#编写，面向.NET平台。
* [Snappy for Windows](https://snappy.machinezoo.com/) - 用于.NET的Snappy 压缩库，基于P/Invoke。
* [Snappy.Sharp](https://github.com/jeffesp/Snappy.Sharp) - 用C#实现的谷歌Snappy 压缩算法。

## 持续集成
* [TeamCity](https://www.jetbrains.com/teamcity/) - 可直接使用，可扩展、开发人员友好的服务器搭建——开箱即用。**[$]**
* [MyGet](https://www.myget.org/) - 为NuGet、NPM、Bower 和 VSIX 提供持续集成、部署、宿主程序包仓库的服务。**[$]**
* [AppVeyor](https://www.appveyor.com/) - 以服务的方式持续构建和部署.NET 。**[$]** **[对开源软件免费]**

## 加密

* [BouncyCastle](https://bouncycastle.org/) - CLR上同.Net System.Security.Cryptography一样的加密算法引用实现。
* [HashLib](https://archive.codeplex.com/?p=hashlib) - HashLib 包含了几乎所有你见过的哈希算法，几乎支持所有东西并且非常容易使用。
* [libsodium-net](https://github.com/adamcaudill/libsodium-net) - 用于.NET的libsodium，一个安全加密库。
* [Pkcs11Interop](https://github.com/Pkcs11Interop/Pkcs11Interop) - 托管.NET包装器，用于非托管的PKCS#11库，该库提供对加密硬件的访问。
* [StreamCryptor](https://github.com/bitbeans/StreamCryptor) - 使用 libsodium 和 protobuf 对流进行加密和解密。
* [SecurityDriven.Inferno](https://github.com/sdrapkin/SecurityDriven.Inferno) - 经过专业审核的.NET加密库。

## 数据库

* [BrightstarDb](https://github.com/BrightstarDB/BrightstarDB) - BrightstarDB 是一个原生的 .NET RDF 三元数据存储。
* [DBreeze](https://github.com/hhblaze/DBreeze) - DBreeze 数据库是开源的嵌入式键值存储。
* [Event Store](https://github.com/EventStore/EventStore) - 开源的功能性数据库，支持使用JavaScript进行复杂事件处理。
* [LiteDB](https://github.com/mbdavid/LiteDB) - 单一数据文件中的 .NET NoSQL Document Store - https://www.litedb.org 。
* [RavenDB](https://github.com/ravendb/ravendb) - 用于.NET支持LINQ的文档数据库。
* [Marten](https://github.com/JasperFx/marten) - PostgreSQL作为文件数据库与数据存储.NET应用。
* [Realm Xamarin](https://github.com/realm/realm-dotnet) - 简单快速的SQLite与ORMs可选替代 - https://realm.io/docs/dotnet/latest/。
* [Streamstone](https://github.com/yevhen/Streamstone) - 用于 Azure Table Storage的事件存储。
* [StringDB](https://github.com/SirJosh3917/StringDB) - StringDB有着模块化、键值对架构，以消耗少量的随机访问内存并生成小型数据库。
* [Ignite](https://github.com/apache/ignite) - Distributed 内存平台：SQL和LINQ支持的文件数据库；分布式计算；分布式服务和事件。
* [Yessql](https://github.com/sebastienros/yessql) - 在任何RDBMS上使用的.NET文件数据库。
* [JsonFlatFileDataStore](https://github.com/ttu/json-flatfile-datastore) - 简单的JSON平面文件数据存储，支持类型化和动态数据。
* [Db4o-gpl](https://github.com/iboxdb/db4o-gpl) - 可以嵌入式和远程连接的面向对象数据库。

## 数据库驱动

* [MySQL Connector](https://dev.mysql.com/downloads/connector/net/) - Connector/Net 是一个用于MySQL的完全托管ADO.NET驱动。
* [Npgsql](https://github.com/npgsql/Npgsql) - PostgreSQL的.Net数据提供者。
* [MongoDB](https://github.com/mongodb/mongo-csharp-driver) - MongoDB官方C#驱动。
* [RethinkDb.Driver](https://github.com/bchavez/RethinkDb.Driver/) - C#中RethinkDB数据库驱动，力争100% ReQL API 兼容和完备性。
* [ServiceStack Redis](https://github.com/ServiceStack/ServiceStack.Redis) - .NET领先的 C# Redis 客户端。
* [StackExchange Redis](https://github.com/StackExchange/StackExchange.Redis) - 源于StackExchange的通用redis客户端。
* [Cassandra](https://github.com/datastax/csharp-driver) - 用于Apache Cassandra的DataStax .NET驱动。
* [Couchbase](https://github.com/couchbase/couchbase-net-client) - Couchbase 官方.NET客户端库，基于Enyim内存缓存客户端。
* [Firebird.NET](https://sourceforge.net/projects/firebird/) - C#开发的.NET数据提供者，提供Firebird API高性能的本地实现。
* [Storage.Net](https://github.com/aloneguid/storage) - 用于诸如Amazon S3, Azure Service Bus, Azure Event Hub, Azure Storage, Azure Data Lake Store等流行云存储的通用存储库抽象与实现。

## 日期

* [NodaTime](https://github.com/nodatime/nodatime) - Noda Time 是一个用于.NET的可选日期与时间API。帮助你更加清晰的思考你的数据，并且在这些数据上更加精确的进行操作。https://nodatime.org/
* [DateTimeExtensions](https://github.com/joaomatossilva/DateTimeExtensions) - `System.DateTime`通用日期时间扩展形式，包括多种文化中的假日与工作日计算。
* [Exceptionless.DateTimeExtensions](https://github.com/exceptionless/Exceptionless.DateTimeExtensions) - 时间范围、工作日和各种各样的`DateTime`、`DateTimeOffset`、`TimeSpan`扩展方法

## 反编译

* [dnSpy](https://github.com/0xd4d/dnSpy) - 开源.NET程序集浏览器、编辑器、反编译器和调试器。
* [ILSpy](https://ilspy.net/) - ILSpy 是一个开源的.NET程序集查看器和反编译器。
* [JustDecompile Engine](https://github.com/telerik/JustDecompileEngine) - [JustDecompile](https://www.telerik.com/products/decompiler.aspx)反编译引擎。
* [dotPeek](https://www.jetbrains.com/decompiler/) - 基于ReSharper附带编译器的免费的单机工具。它可以把任何.NET程序集可靠的编译到等价的C#或IL代码。它能够基于原始的二进制文件直截了当的创建Visual Studio解决方法案。**[专利所有][免费]**

## 部署

* [Unfold](https://github.com/thomasvm/unfold) - .NET web 应用的基于PowerShell的部署方案。
* [DbUp](https://github.com/DbUp/DbUp) - 帮助你部署更新到SQL Server 数据库的.NET库。它能够追踪已经在运行的SQL脚本，然后运行需要更新的脚本使数据库达到最新版本。
* [Octo Pack](https://github.com/OctopusDeploy/OctoPack) - 使用 Octopus Deploy一类的工具来部署用于构建应用的NuGet包。
* [yuniql](https://github.com/rdagumampan/yuniql) - .NET Core制作的免费开源计划版本控制与迁移工具。在普通目录中用简单的SQL来运行迁移和处理版本，并且通过单机CLI（不需要CLR）、Azure Pipelines、Docker 或 ASP.NET Core 代码从CSV来埋藏你的数据。https://yuniql.io

## DirectX

* [Vortice.Windows](https://github.com/amerkoleci/Vortice.Windows) - 用于 DirectX, WIC, Direct2D1, XInput, XAudio 和 X3DAudio 的跨平台.NET标准库。

## 分布式计算

* [.NEXT Raft](https://github.com/sakno/dotNext/tree/master/src/cluster) -  .NET 和 ASP.NET Core 的Raft实现，可以通过分布式共识和复制来构建群集微服务。
* [Orleans](https://github.com/dotnet/orleans) - Orleans 由微软学术开发，是一个可以直截了当的构建分布式大规模计算应用的框架，不需要学习和使用复杂的并发或其它缩放模式。
* [Orleankka](https://github.com/OrleansContrib/Orleankka) - Orleankka 是 Microsoft Orleans 框架的功能性API。它非常适合具有可组合、统一通信接口的场景，如CQRS、事件源(event-sourcing)、 路由重发(re-routin)、FSM等。用于F#的此API叫做 Orleankka.FSharp。
* [Akka.net](https://github.com/akkadotnet/akka.net) - Akka.NET 是流行的Java/Scala框架Akka的.NET版本，这是由社区提供的与Typesafe（原始的 Java、Scala 版本的开发商）无关。
* [Zebus](https://github.com/Abc-Arbitrage/Zebus) - Zebus 是一个内部由CQRS规则构建的轻量级、高度通用、点对点的服务总线。它能够让应用间以一种快速和容易的方式进行通信，最复杂的部分被隐藏在所要使用的库中，这样你就能聚焦于代码中困扰着你的难题，而不用调试消息传递代码，对于任何分布式应用来说这是一个基础。
* [FsShelter](https://github.com/Prolucid/FsShelter) - 用于授权[Apache Storm](https://storm.apache.org)组件和拓扑逻辑的F#库，对分布式和容错事件流处理提供高阶抽象。
* [Foundatio](https://github.com/FoundatioFx/Foundatio#jobs) - 用于构建分布式应用的可插拔基础块。
* [MBrace](https://github.com/mbraceproject) - 在云上集成数据脚本。
* [protoactor-dotnet](https://github.com/AsynkronIT/protoactor-dotnet) - Proto Actor - 适用于Golang和C#的超快分布式Actor。

## DLR

* [cmd](https://github.com/manojlds/cmd) - 用一种简单的方式来运行外部程序的C#库。阐述了C#的“动态”功能。

## 文档

* [Sandcastle](https://github.com/EWSoftware/SHFB) - 类似于 NDoc 的 Sandcastle Help File Builder。
* [SharpDox](https://github.com/Geaz/sharpDox) - C#文档工具。
* [SourceBrowser](https://github.com/KirillOsenkov/SourceBrowser) - 源码浏览器网站生成器支持。https://referencesource.microsoft.com
* [Swashbuckle](https://github.com/domaindrivendev/Swashbuckle.WebApi) - 给WebApi项目无缝地添加swagger文档。
* [F# Formatting](https://fsprojects.github.io/FSharp.Formatting/) - F#和C#项目的文档工具，文档生成自F#脚本文件、Markdown文档、内嵌XML或 Markdown评论。
* [DocFX](https://github.com/dotnet/docfx) - .NET项目构建和发布API文档的工具。
* [DocNet](https://github.com/FransBouma/DocNet) - 友好的静态文档生成器，使用markdown文件来创建内容。

## 电子商务和支付

* [Paypal Merchant SDK](https://github.com/paypal/merchant-sdk-dotnet) - Paypal Merchant官方.NET SDK。
* [NopCommerce](https://github.com/nopSolutions/nopCommerce) - nopCommerce. 免费开源的电子商务购物车(ASP.NET Core)。
* [ServiceStack.Stripe](https://github.com/ServiceStack/Stripe) - 针对 stripe.com REST API 的强类型.NET客户端。
* [SmartStoreNET](https://github.com/smartstore/SmartStoreNET) - 免费 ASP.NET MVC 电子商务购物车解决方案。
* [Stripe.Net](https://github.com/stripe/stripe-dotnet) - Stripe.net 为 https://stripe.com/ 提供完整的.NET API服务。
* [Virto Commerce](https://github.com/VirtoCommerce/vc-platform) - Virto Commerce 是第二个版本，也是唯一的开源许可下的企业级别电子商务产品。Virto Commerce 基于 .NET 4.5，使用了 MVC、IoC、EF、Azure、Angular JS 等其他先进技术。它可以在微软的云平台（Azure）、亚马逊云服务（AWS）和企业内部部署。https://virtocommerce.com
* [SimplCommerce](https://github.com/simplcommerce/simplcommerce) - 基于.NET Core的超级简单电子商务系统。易于使用且易于二次开发，由于有了.NET Core，你可以使用各种RDBMS(如Microsoft SQL Server、PostgreSQL、MySQL)在Linux、Windows上运行SimplCommerce。
* [GrandNode](https://github.com/grandnode/grandnode) - GrandNode 是一个给苛刻用户开发的多功能跨平台电子商务解决方案，可以在任何系统(Linux、Windows、Mac)上运行。GrandNode支持Docker，因此亦可在Docker的Linux容器上安装。可扩展的电子商务解决方案，能够独立适用于来自各种规模与行业的公司。
* [Square](https://github.com/square/connect-csharp-sdk) - Square支付和其它SquareAPI官方SDK。

## 环境管理

* [Dotnet CLI](https://github.com/dotnet/cli) - .NET Core跨平台命令行工具链使用程序。

## ETL

* [Cinchoo ETL](https://github.com/Cinchoo/ChoETL) - .NET的ETL框架(读/写CSV、Flat、Xml、JSON、Key-Value格式文件)
* [Reactive ETL](https://archive.codeplex.com/?p=reactiveetl) - Reactive ETL 使用.NET反应式扩展对Rhino ETL重写。

## 时间聚合器和发送器

* [Mediator.Net](https://github.com/mayuanyang/Mediator.Net) - 用于发送指令、发布事件和请求响应的支持管道的.Net简单中介者。
* [MediatR](https://github.com/jbogard/MediatR) - .NET中朴实无华的中介者实现。
* [Rx Event Aggregator](https://mikebridge.github.io/articles/csharp-domain-event-aggregator/) - 源自Reactive.EventAggregator的超级简单的反应式扩展代码。
* [TinyMessenger](https://github.com/grumpydev/TinyMessenger) - 松耦合通信的轻量级事件聚合器/发送器。
* [Xer.Cqrs](https://github.com/XerProjects/Xer.Cqrs) - 基于CQRS模式创建应用并支持属性路由和托管处理程序的简单库，由C#开发针对.NET Standard 1.0。
* [FluentMediator](https://github.com/ivanpaulovich/FluentMediator) - FluentMediator 是允许开发人员创建自定义管道用于命令、查询和事件的库。

## 异常
* [Exceptionless](https://github.com/exceptionless/Exceptionless.Net) - Exceptionless .NET 客户端。

## 扩展库
* [ExtensionMethods.Net](https://www.extensionmethod.net/csharp) - 扩展方法集的网站。
* [Z.ExtensionMethods](https://github.com/zzzprojects/Z.ExtensionMethods) - 超过1000种有用的扩展方法。

## 函数式编程

* [language-ext](https://github.com/louthy/language-ext) - 这个库极大的使用了C# 6+的特性以提供多功能的‘基础类库’，那样你在看的时候就会感觉其像语言自身的扩展。它也包含‘类Erlang’过程系统(actors)，能够有选择的持久化信息与状态到Redis（应用内部的消息发送可以在没有Redis的情况下进行）。 过程系统还支持信息与状态的Rx流，是允许反应式事件和信息派发的完整系统。
* [Optional](https://github.com/nlkl/Optional) - C#鲁棒性option类型。
* [JFlepp.Maybe](https://github.com/jflepp/JFlepp.Maybe) - C# Maybe类型，旨在作为F#至C#中符合语言习惯的option类型。
* [Optuple](https://github.com/atifaziz/Optuple) - 低调的给出`(bool, T)`类Option句法的.NET标准库，即对于库或其用户来说不会有新的option类型依赖。

## 游戏

* [MonoGame](https://github.com/MonoGame/MonoGame) - 创建跨平台游戏的强大框架。
* [CocosSharp](https://github.com/mono/CocosSharp) - CocosSharp 是 Cocos2D 和 Cocos3D API 的 C# 实现版本，可以在所有支持 MonoGame 的平台上运行。
* [Duality](https://github.com/AdamsLair/duality) - Duality 是一个2D游戏开发框架，专注于功能的模块化，自带一个可视化编辑器。
* [Stride Game Engine](https://stride3d.net/ ) - Stride Game Engine 是一个2D/3D跨平台游戏引擎，特征是有一个场景编辑器、颗粒度、物理渲染(PBR)、脚本及其它。
* [Wave Engine](https://waveengine.net/Engine) - Wave engine 是一个免费的基于组件的现代游戏引擎，能够创建跨平台游戏，支持Kinect、Oculus Rift、Vuforia、Cardboard、Leap Motion 及其它。**[免费][专利所有]**
* [UrhoSharp](https://github.com/xamarin/urho) - UrhoSharp 是Urho3D游戏引擎的C#实现，运行在iOS,、Mac、Windows、Android 和 Linux 系统上。
* [Nez](https://github.com/prime31/Nez) - Nez 关注2D的免费框架，需要和MonoGame及FNA一起使用。
* [BEPUphysics](https://github.com/bepu/bepuphysics2) - 纯 C# 3D 物理库。
* [Devtodev](https://github.com/devtodev-analytics/winstore-sdk) - 游戏开发者全周期分析解决方案。
* [UnrealCLR](https://github.com/nxrighthere/UnrealCLR) - 集成.NET Core的Unreal引擎。

## GIS

 * [NetTopologySuite](https://github.com/NetTopologySuite/NetTopologySuite/)  一个在.NET平台上实现快速、可靠的GIS系统解决方案。
 * [SharpMap](https://github.com/SharpMap) 一个易于使用的地图库，可以用于web和桌面应用。
 * [OsmSharp](https://www.osmsharp.com/) - 配合OpenStreetMap (OSM) 数据使用的C#库，提供对OSM数据的读、写和路由规划。
 * [GeoJSON4EntityFramework](https://github.com/alatas/GeoJSON4EntityFramework) - 从 Entity Framework Spatial Data 或著名的Text(WKT)输入创建GeoJSON的库。
 * [GeoJSON.NET](https://github.com/GeoJSON-Net/GeoJSON.Net) - 用于GeoJSON类型和对应的Json.Net(de)序列化工具的.NET库。
 * [CoordinateSharp](https://github.com/Tronald/CoordinateSharp) - 基于太阳/月球信息轻松的解析或转换坐标格式和计算位置信息。
 * [DEM Net Elevation API](https://github.com/dem-net/dem.net) - Digital Elevation Models的.NET库, 能够以glTF/STL格式生成3D地形。

## Git工具

* [Bonobo Git Server](https://github.com/jakubgarfield/Bonobo-Git-Server) - Bonobo Git Server for Windows 是一个web应用，可以安装在自己的IIS上，用于管理和连接git仓库。https://bonobogitserver.com/
* [GitExtensions](https://github.com/gitextensions/gitextensions) - GitExtensions 是shell扩展、Visual Studio 2008/2010/2012/2013 插件和一个独立的 Git 仓库工具。https://gitextensions.github.io/
* [GitLink](https://github.com/GitTools/GitLink) - 让用户可以单步调试托管在 GitHub 或 BitBucket 上的代码。
* [GitVersion](https://github.com/GitTools/GitVersion) - 根据Git仓库状态生成一个语义化版本号（Semantic Version Number）。
* [LibGit2Sharp](https://github.com/libgit2/libgit2sharp) - LibGit2Sharp 带来了libgit2所有的功能和速度，是一个本地Git实现，可以运行在.Net和Mono平台。
* [GitRead.Net](https://github.com/kingsimmy/GitRead.Net) - GitRead.Net 是.NET标准库，可以非常容易的对存储在磁盘上的内容询问Git仓库。它还能枚举提交日志并提交中计算每一个文件的行数并列出文件变化。
* [NGit](https://github.com/mono/ngit) - NGit 是JGit移植到C# 的版本。
* [posh-git](https://github.com/dahlbyk/posh-git) - Git的PowerShell环境。
* [RepoZ](https://github.com/awaescher/RepoZ) - 有着Windows Explorer 和 CLI-enhancements的Git仓库信息聚合器。
* [Git Credential Manager for Windows](https://github.com/Microsoft/Git-Credential-Manager-for-Windows) - 微软制作的用于帮助解决证书问题。

## 图形

* [LibTessDotNet](https://github.com/speps/LibTessDotNet) - 知名的 GLU Tessellator .NET 端口，三角剖分算法。
* [Oxyplot](https://github.com/oxyplot/) - .NET 跨平台绘图库。
* [OpenTK](https://github.com/opentk/opentk) - 封装了OpenGL、OpenCL和OpenAL的高级底层C#开发库。
* [NGraphics](https://github.com/praeclarum/NGraphics) - .NET 跨平台矢量图形渲染库。
* [Live-Charts](https://github.com/Live-Charts/Live-Charts) - 活动的，面向MVVM的以及现代的绘表库。
* [Helix Toolkit](https://www.helix-toolkit.org) - .NET 3D组件库。
* [AssimpNet](https://bitbucket.org/Starnick/assimpnet) - Open Asset Importer ("Assimp")的跨平台.NET标准包装器。该库可以导入、处理和导出#D模型用于渲染图形/游戏应用。对于导入功能支持超过40种格式(如：OBJ、FBX、GLTF、3DS、Collada)，这些格式的子集也能被导入(如：OBJ、GLTF、3DS、Collada)。对于实时渲染，网格处理功能可以集成或优化网格数据。
* [Silk.NET](https://github.com/Ultz/Silk.NET) - 许多高级API的跨平台、高性能、低阶.NET标准包装器，如OpenGL、OpenCL、OpenAL、OpenXR、Assimp、GLFW以及其它。此外还能包装本地API，包括自己的Windowing和Input抽象。 使得使用Silk.NET开发游戏和应用变得轻而易举，3D应用开发者所需的东西应有尽有。
* [Veldrid](https://github.com/mellinoe/veldrid) - .NET低阶、可移植图形和计算库。
* [RealTimeGraphX](https://github.com/royben/RealTimeGraphX) - RealTimeGraphX 是用于WPF、UWP和Xamarin Forms(不久后实现)的与数据类型无关的高性能绘图库。

## GUI

* [HandyControl](https://github.com/HandyOrg/HandyControl) - 包含一些简单常用的WPF控件。
* [Lara](https://github.com/integrativesoft/lara) - Lara Web Engine 是C#中用于开发Web用户接口的库。
* [QtSharp](https://github.com/ddobrev/QtSharp) - 用于Qt的Mono/.NET Bindings。
* [Qml.Net](https://github.com/qmlnet/qmlnet) - Mono/.NET/.NET Core 的跨平台 Qml/.NET 集成。
* [MahApps.Metro](https://github.com/MahApps/MahApps.Metro) - 用于创建Metro风格的WPF应用工具箱。
* [Callisto](https://github.com/timheuer/callisto) - 用于 Windows 8 XAML 应用的控件工具箱。包含若干UI控件，让你更容易地创建符合 Windows UI 风格规范的Windows商店应用。
* [ObjectListView](http://objectlistview.sourceforge.net/cs/index.html) - ObjectListView 使用C#封装了.NET的ListView控件，使得ListView更加易用，并且加入了一些新特性。
* [DockPanelSuite](https://sourceforge.net/projects/dockpanelsuite/) - 灵感来自 Visual Studio 的停靠窗口(docking)类库，用于.NET WinForm应用。
* [AvalonEdit](https://github.com/icsharpcode/AvalonEdit) - 在SharpDevelop中使用，基于WPF的文本编辑器组件。
* [XWT](https://github.com/mono/xwt) - 跨平台UI工具箱，用于创建.NET和Mono桌面应用程序。
* [Gtk#](https://github.com/mono/gtk-sharp) - Gtk#是Gtk+ GUI 工具箱的Mono/.NET版本，绝大多数Mono中的GUI应用都基于它构建。
* [MaterialDesignInXamlToolkit](http://materialdesigninxaml.net/) - 用于创建Material Design风格的WPF应用工具箱。
* [Eto.Forms](https://github.com/picoe/Eto) - 跨平台GUI框架，用于.NET和Mono的桌面和移动应用。
* [Dragablz](https://github.com/ButchersBoy/Dragablz) - 可拖拽、可分离（tearable，译者注：即拖拽标签页成为独立窗口）的WPF标签页控件（类似 Chrome）。支持布局和主题，包含兼容 MahApps 和 Material Design 的主题。
* [Fluent.Ribbon](https://github.com/fluentribbon/Fluent.Ribbon) - Fluent Ribbon Control Suite 是一个在WPF中实现Office和 Windows 8 风格的Ribbon库。
* [Office Ribbon](https://github.com/RibbonWinForms/RibbonWinForms) - 为WinForms实现 MS Office Ribbon 的库。
* [MaterialSkin](https://github.com/IgnaceMaes/MaterialSkin) - .NET WinForms, C# 或 VB.Net 主题适配 Google's Material Design 原则。
* [Xamarin.Forms](https://github.com/xamarin/Xamarin.Forms) - 从单独、共享的C#代码库构建用于iOS、Android和Windows的本地UI。 
* [SciterSharp](https://github.com/ramon-mendes/SciterSharp) - 除了HTML外还使用Sciter(商业使用也是免费的)引擎的所有特性：CSS3, SVG, scripting, AJAX, &lt;video&gt;...来创建.NET跨平台桌面应用。
* [Empty Keys UI](https://www.emptykeys.com/ui_library/) - 基于用户界面库的富平台与富引擎XAML。**[免费][专利所有]**
* [UWP Community Toolkit](https://github.com/windows-toolkit/WindowsCommunityToolkit) - UWP Community Toolkit 包括了帮助器功能、自定义控件和应用服务，简化和阐述了针对Windows 10的开发UWP应用常见开发任务。
* [ScintillaNET](https://github.com/jacobslusser/ScintillaNET) - 用于Scintilla文本编辑器组件(通过Notepad++使用Scintilla)的Windows Forms。
* [FastColoredTextBox](https://github.com/PavelTorgashov/FastColoredTextBox) - Fast Colored TextBox 是用于.NET的文本编辑器组件。可以创建有语法高亮的自定义文本编辑器。在小型、中型、大型及超大型文件上工作良好。
* [Avalonia](https://github.com/AvaloniaUI/Avalonia) - 多平台.NET UI控件(即之前的Perspex)。
* [Modern UI for WPF - MUI](https://github.com/firstfloorsoftware/mui) - 把WPF应用转换为看起来很不错的现代UI应用的控件和类型集。
* [WinApi](https://github.com/prasannavl/WinApi) - 简单、直接、超薄的CLR库用于有着自动化、开窗术(windowing)、DirectX、OpenGL和Skia帮助器的高性能 Win32 Native Interop。
* [Neutronium](https://github.com/NeutroniumCore/Neutronium) - 使用HTML、CSS、javascript和MVVM绑定来构建 WPF .NET 桌面应用。
* [Ooui](https://github.com/praeclarum/Ooui) - 小型跨平台UI库，将本机UI开发的简单性带到web。
* [AdonisUI](https://github.com/benruehl/adonis-ui) - 轻量级UI工具箱，为WPF应用提供经典但加强版的Windows视觉。
* [Windows UI Library](https://github.com/microsoft/microsoft-ui-xaml) - Windows UI 库(WinUI)，为 Windows UWP 提供官方的本机 Microsoft UI 控件和功能。
* [Bunifu UI Framework](https://bunifuframework.com) - 精心制作的Winforms控件和组件，用于创建相当不错的现代应用UI。**[$]**
* [Ookii.Dialogs.Wpf](https://github.com/augustoproiete/ookii-dialogs-wpf) - 为WPF应用提供常见的Windows对话框，如：任务对话框、证书对话框、进度条对话框、目录浏览对话框及其它。
* [Ookii.Dialogs.WinForms](https://github.com/augustoproiete/ookii-dialogs-winforms) - 为 Windows Forms 应用提供常见的Windows对话框，如：任务对话框、证书对话框、进度条对话框、目录浏览对话框及其它。

## HTML and CSS

* [AngleSharp](https://github.com/AngleSharp/AngleSharp) - 支持构建完整的 HTML5 DOM 和 CSS3 模型。
* [dotless](https://github.com/dotless/dotless) - ruby Less CSS 库的.NET移植版本。http://www.dotlesscss.org
* [ExCSS](https://github.com/TylerBrinks/ExCSS) - C#的CSS3解析器开发库。
* [HtmlAgilityPack](https://html-agility-pack.net/?z=codeplex) - 一个灵活的HTML解析器，可以对DOM进行读写，支持XPATH和XSLT。
* [LibSass Host](https://github.com/Taritsyn/LibSassHost) - 支持虚拟文件系统的围绕[libSass](https://sass-lang.com/libsass)库的.NET包装器。
* [LtGt](https://github.com/Tyrrrz/LtGt) - 轻量级HTML处理器，可以用于解析与导航DOM，处理CSS选择器，还可以转换成Linq2Xml，容易扩展等等。

## HTTP

* [Tiny.RestClient](https://github.com/jgiacomini/Tiny.RestClient) - 最简单的.NET Fluent REST 客户端。
* [Http.fs](https://github.com/haf/Http.fs) - `[F#]`中的一个函数式HTTP客户端。
* [RestSharp](https://github.com/restsharp/RestSharp) - .NET下简单的REST和 HTTP API 协议客户端。
* [Flurl](https://flurl.dev) - 流畅、可移植、可测试的REST/HTTP客户端库。
* [EasyHttp](https://github.com/EasyHttp/EasyHttp) - C# Http 库。
* [Refit](https://github.com/reactiveui/refit) - Xamarin 和 .NET 下自动化类型安全的REST库。
* [RestEase](https://github.com/canton7/RestEase) - 类型安全且易于使用的 REST API 客户端库，简单可定制。大部分灵感来自Refit。
* [RestLess](https://github.com/letsar/RestLess) - .Net Standard 自动化类型安全无反射 REST API 客户端库。
* [HttpClientGoodies](https://github.com/jeffijoe/httpclientgoodies.net) - 与`HttpClient`一起使用的工具。
* [CoreRPC](https://github.com/kekekeks/CoreRPC) - 针对netstandard1.3类WCF RPC 可扩展库，兼容.NET、Mono和.NET Core。

## IDE

* [AvalonStudio](https://github.com/VitalElement/AvalonStudio) - C#开发的可扩展、跨平台IDE，用于嵌入式C/C++、.NET Core、Avalonia和Typescript。
* [SharpDevelop](https://github.com/icsharpcode/SharpDevelop) - 用于.NET编程语言的免费IDE。
* [MonoDevelop](https://github.com/mono/monodevelop) - 跨平台IDE，主要面向Mono/.NET开发者。
* [Visual Studio Express](https://visualstudio.microsoft.com/vs/express/) - 用于.NET编程的Visual Studio免费、轻量版。
* [Visual Studio Community](https://visualstudio.microsoft.com/vs/community/) - 功能完整的IDE。
* [Waf DotNetPad](https://jbe2277.github.io/dotnetpad/) - 简单快速的代码编辑器，让C#或Visual Basic编程充满乐趣。
* [Visual Studio Code](https://code.visualstudio.com/) - 微软开发的基于Electron的超棒的开源编辑器。
* [Ionide](http://ionide.io/) - Atom Editor 和 Visual Studio Code 包套件，用于F#跨平台开发。
* [Rider](https://www.jetbrains.com/rider/) - 基于IntelliJ平台和ReSharper的跨平台 C# IDE。
* [RoslynPad](https://github.com/aelij/RoslynPad) - 基于Roslyn和AvalonEdit简单C#编辑器。
* [Consulo](https://consulo.io) - 支持C#和Java的跨平台编辑器，IntelliJ IDEA Community Edition的分支。

## 图像处理

* [ImageResizer](https://imageresizing.net/) - 在图片URL后增加命令，几毫秒内可获取修改后的版本，支持对图片实时缩放和编辑。
* [ImageProcessor](https://github.com/JimBobSquarePants/ImageProcessor) - 开源.NET库，用于实时处理图片。
* [ImageSharp](https://github.com/SixLabors/ImageSharp) - 图像文件处理的跨平台完全管理库。
* [DynamicImage](https://dynamicimage.apphb.com/) - 高性能开源图片处理库，用于ASP.NET。
* [MetadataExtractor](https://github.com/drewnoakes/metadata-extractor-dotnet) - 从图片中提取Exif、IPTC、XMP、ICC等其它元数据信息。
* [Emgu CV](http://www.emgu.com/wiki/index.php/Main_Page) - OpenCV的.NET跨平台封装。
* [DotImaging](https://github.com/dajuric/dot-imaging) - 简约的.NET图像移植平台。
* [Magick.NET](https://github.com/dlemstra/Magick.NET) - ImageMagick库的.NET封装。
* [OpenCvSharp](https://github.com/shimat/opencvsharp/) - 用于.NET框架的OpenCV跨平台封装。
* [TeximpNet](https://bitbucket.org/Starnick/teximpnet) -读/操作/写图像文件的跨平台 .NET Standard 库。在图形/游戏应用中主要用于创建2D/3D/Cubemap结构，尤其是将图像转换为GPU压缩格式并生成mipmap。该库封装FreeImage本地库以导入/导出超过30种图像格式，还封装 Nvidia Texture Tools 本地库用于GPU压缩。它还有C#开发的全功能DDS格式导入/导出。
* [Colourful](https://github.com/tompazourek/Colourful) - 开源.NET库用于使用彩色空间。
* [Imgix-CSharp](https://docs.imgix.com/libraries/imgix-csharp) - 轻松的把图像url更新为快速且可响应的。 **[$]**

## 安装工具

* [Wix Toolset](https://wixtoolset.org/) - 强大的工具集，用于创建自己的Windows安装程序。
* [Squirrel](https://github.com/squirrel/squirrel.windows) - Squirrel 既是工具集也是库，对Windows桌面应用的安装和更新进行完全管理。
* [Chocolatey](https://github.com/chocolatey/choco) - 类似`yum`或`apt-get`，但是用于Windows。
* [Wax](https://marketplace.visualstudio.com/items?itemName=TomEnglert.Wax) - WiX项目的交互式编辑器。
* [Onova](https://github.com/Tyrrrz/Onova) - 桌面应用的自动更新框架。

## 国际化

* [i18n](https://github.com/turquoiseowl/i18n) - ASP.NET MVC 智能国际化工具。
* [MessageFormat.NET](https://github.com/jeffijoe/MessageFormat.NET) - .NET实现的ICU MessageFormat，让你开发情景UI消息(PCL库)。
* [ResX Resource Manager](https://github.com/dotnet/ResXResourceManager) - 最流行的免费工具，用基于resx的资源来本地化所有类型的应用。

## 互操作

* [CppSharp](https://github.com/mono/CppSharp) - C#表层C++ API工具。
* [Sharpen](https://github.com/mono/sharpen) - Sharpen 是 db4o开发的Eclipse插件，可以把Java项目转换为C#。
* [CXXI](https://github.com/mono/cxxi) - C++互操作框架。
* [pythonnet](https://github.com/pythonnet/pythonnet) - Python和.NET互操作框架。
* [PInvoke Interop Assistant](https://github.com/jaredpar/pinvoke-interop-assistant) - 把C转换为托管P/Invoke签名或verse visa.
* [pinvoke](https://github.com/dotnet/pinvoke) - 用于最新Windows操作系统的包含P/Invoke代码的库。
* [LegacyWrapper](https://github.com/CodefoundryDE/LegacyWrapper) - LegacyWrapper使用封装过程从对立体系结构(x86或AMD64)的过程来调用DLL。
* [Pyrolite](https://github.com/irmen/Pyrolite) - 使用Python世界轻松的将Java或.NET程序变为接口，在源查项目上使用Pyro协议调用方法。

## IoC

* [Castle Windsor](https://github.com/castleproject/Windsor) - Castle Windsor 是一个用于.NET和Silverlight的成熟的控制反转(IoC)容器。
* [Unity](https://github.com/unitycontainer/unity) - 轻量级、可扩展的依赖注入容器，支持构造函数、属性和方法调用注入。
* [Autofac](https://github.com/autofac/Autofac) - 令人着迷的 .NET IoC 容器。
* [DryIoc](https://github.com/dadhi/DryIoc) - 简单、快速的全功能IoC容器。
* [Ninject](https://github.com/ninject/ninject) - 像忍者一样的.NET依赖注入器。
* [Spring.Net](https://github.com/spring-projects/spring-net) - Spring.NET 是一个开源应用程序框架，可以便捷地创建企业级.NET应用。
* [Lamar](https://jasperfx.github.io/lamar/) - 快速的IoC容器，针对 ASP.NET Core 和其它.NET服务应用的使用进行了高度优化。
* [LightInject](https://github.com/seesharper/LightInject) - 一个超轻量级IoC容器。
* [Simple Injector](https://github.com/simpleinjector/SimpleInjector) - Simple Injector 是 .NET 4+ 上一个易于使用的依赖注入(DI)库，支持Silverlight 4+、Windows Phone 8、Windows 8 包括通用app和mono。
* [Microsoft.Extensions.DependencyInjection](https://github.com/aspnet/DependencyInjection) - ASP.NET Core应用默认IoC容器。
* [Scrutor](https://github.com/khellang/Scrutor) - Microsoft.Extensions.DependencyInjection的嵌入式扫描扩展。
* [VS MEF](https://github.com/Microsoft/vs-mef) - 使用 Visual Studio 实现的 Managed Extensibility Framework (MEF)。
* [TinyIoC](https://github.com/grumpydev/TinyIoC) - 易于使用、轻松无忧的IoC，用于小型项目、库和初学者。
* [Stashbox](https://github.com/z4kn4fein/stashbox) - 基于.NET解决方案的轻量级、可移植依赖注入框架。

## JavaScript引擎

* [ClearScript](https://github.com/Microsoft/ClearScript) - 轻松添加脚本到.NET应用的库，目前支持JavaScript (via V8 and JScript) 和 VBScript。
* [Edge.js](https://github.com/tjanczuk/edge) - 在Windows、macOS和Linux上实时运行.NET和Node.js代码。
* [Jint](https://github.com/sebastienros/jint) - .NET的JavaScript翻译员，完全符合ECMA 5.1，并且能够运行在任何.NET平台上。
* [Jurassic](https://github.com/paulbartrum/jurassic) - ECMAScript语言和运行时的实现，旨在为.NET提供JavaScript的最佳性能与最符合标准的实现。

## 日志

* [Essential Diagnostics](https://github.com/sgryphon/essential-diagnostics) - 为内置System.Diagnostics 命名空间扩展功能，提供更灵活的日志功能。
* [NLog](https://github.com/nlog/NLog/) - NLog - 先进的.NET和Silverlight日志工具。
* [Logazmic](https://github.com/ihtfw/Logazmic) - 用于Windows的开源NLog查看器。
* [ELMAH](https://elmah.github.io/) - 官方的ELMAH站点。
* [Elmah MVC](https://github.com/alexbeletsky/elmah-mvc) - MVC版Elmah。
* [Logary](https://github.com/logary/logary) - 是一个mono和.Net平台下高性能、多目标的日志、度量、追踪和健康检查库。支持多目标，为微服务构建。
* [Log4Net](https://logging.apache.org/log4net/) - Apache log4net 库是一个工具用于帮助程序员向多个不同的目标输出日志。
* [Rollbar.NET](https://github.com/rollbar/Rollbar.NET) - 在使用Rollbar.com时简化实时远程错误监控。用于任何.NET技术栈的开源 Rollbar Notifier SDK。这个SDK可以用于任何构建于如下版本的应用中：.NET Core 2.0+、.NET Standard 2.0+、.NET Full Framework 4.5.1+、Mono、Xamarin，以及.NET Standard 2.0+的所有实现。基于异常数据、线索数据、信息性消息和遥测数据它简化了构建数据负载，并且把这些负载发送给 Rollbar API 用于远程监控和分析宿主应用的表现。
* [Sentry](https://github.com/getsentry/sentry-dotnet) - 用于[Sentry](https://sentry.io/welcome/)开源错误追踪的.NET SDK，帮助开发人员实时监控和修复崩溃。
* [Serilog](https://github.com/serilog/serilog) - 一个NoSQL时代下简单直接的日志库。将多个优秀的传统结构化分析日志功能合并到一个易于使用的程序集中。
* [StackExchange.Exceptional](https://github.com/NickCraver/StackExchange.Exceptional) - Stack Exchange 网络使用的错误处理程序。
* [Semantic Logging Application Block (SLAB)](https://github.com/MicrosoftArchive/semantic-logging) - 为内置System.Diagnostics.Tracing命名空间(EventSource类)扩展功能，支持将日志记录到多个容器中，包括Azure表存储、数据库、文件(JSON、XML、文本文件)。通过ETW支持进程内和进程外的日志记录，支持Rx进行实时的事件过滤和聚合。
* [Foundatio](https://github.com/FoundatioFx/Foundatio#logging) - 流畅的记日志API，可以用于通过你的程序记录消息。
* [Exceptionless](https://github.com/exceptionless/Exceptionless.Net) - Exceptionless .NET 客户端。
* [Loupe](https://onloupe.com) - 中心化.NET日志记录与监控。 **[专利所有]** **[免费套餐]**
* [elmah.io](https://elmah.io) - 使用ELMAH给 .NET web 应用云记日志，在上线前发现bug。强有力的集成了Slack、GitHub、Visual Studio等的搜索和API。 **[[对开源软件免费](https://elmah.io/sponsorship/opensource)]** **[$]**
* [BugSnag](https://docs.bugsnag.com/platforms/dotnet/) - 记录错误，包括有用的诊断信息，如stack trace、session、release等。有免费的套餐。 **[对开源软件免费][$]**

## 机器学习和数据科学

* [Infer.NET](https://dotnet.github.io/infer/) - 在绘图模型上运行Bayesian接口的框架，亦可用于概率编程。
* [Accord.NET](http://accord-framework.net/) - 机器学习框架，包含了音频和图像处理的库(计算机视觉、计算机听觉、信号处理和统计)。
* [Accord.NET Extensions](https://github.com/dajuric/accord-net-extensions) - 高级图像处理和计算机视觉算法扩展。
* [AForge.NET](http://www.aforgenet.com/) - 为计算机视觉和人工智能领域的开发者和研究人员提供的框架(包括图像处理、神经网络、遗传算法、机器学习、机器人科学)。
* [Catalyst](https://github.com/curiosity-ai/catalyst) 跨平台自然语言处理(NLP)库，受spaCy的启发，有着预先训练的模型和灵活的实体识别模型，对训练单词和嵌入式文档提供开箱即用的支持，是[SciSharp Stack](https://scisharp.github.io/SciSharp/)的一部分。
* [Deedle](https://bluemountaincapital.github.io/Deedle/) - 处理探索性数据的数据帧和时序库，支持C#和F#。
* [FsLab](https://fslab.org/) - 数据科学和机器学习库的集合，支持F#和.NET。
* [GeneticSharp](https://github.com/giacomelli/GeneticSharp) - 用于 .NET Core 和 .NET Framework 的多平台遗传算法库。这个库对遗传算法算子有着多种实现，如：选择、交叉、变异、再插入和终止。
* [numl](https://github.com/sethjuarez/numl) - 包含最流行的监督学习和无监督学习算法，尽量减少创建预测模型时的冲突。
* [ML.NET](https://github.com/dotnet/machinelearning) - 跨平台机器学习框架，使机器学习对.NET开发者来说变为可能。
* [R Provider](https://bluemountaincapital.github.io/FSharpRProvider/) - 将R语言包和函数封装为类型安全的类型提供程序供F#调用。
* [F# Data](https://fsharp.github.io/FSharp.Data/) - F#类型提供方，访问XML、JSON、CSV和HTML文件（基于样例文档），以及WorldBank数据。
* [Spreads](https://github.com/Spreads/Spreads/) - 用于数据流的实时与探索分析的Series和Panels，Spreads库的性能和内存使用得到优化，其速度数倍于其它开源项目。
* [SciSharp STACK](https://scisharp.github.io/SciSharp/) - 由最流行的Python库转化的C#创建的用于.NET的富机器学习生态。
* [Synapses](https://github.com/mrdimosthenis/Synapses) - F#开发的内存神经网络库。

## Markdown处理器

* [MarkdownSharp](https://code.google.com/archive/p/markdownsharp) - C#实现的开源Markdown处理器，如Stack Overflow所示。
* [F# Formatting](https://fsprojects.github.io/FSharp.Formatting/) - 用于生成F#和C#项目文档的工具。该工具库的核心组件中包含了可扩展的Markdown解析器。
* [CommonMark.NET](https://github.com/Knagis/CommonMark.NET) - CommonMark规范的C#实现，用于将Markdown文档转换为HTML，对最佳性能和可移植性进行了优化。
* [markdig](https://github.com/lunet-io/markdig) - 用于.NET的快速、强大、符合CommonMark的Markdown处理器扩展。

## 邮件

* [FluentEmail](https://github.com/lukencode/FluentEmail) - System.Net.Mail的封装，支持Razor模板引擎。
* [MailKit](https://github.com/jstedfast/MailKit) - 基于MimeKit构建的完整的跨平台的邮件协议栈，包括 IMAP、POP3、SMTP。
* [MimeKit](https://github.com/jstedfast/MimeKit) - 跨平台 .NET MIME 创建和解析库，支持 S/MIME、PGP、TNEF 和 Unix mbox spools。
* [PreMailer.Net](https://github.com/milkshakesoftware/PreMailer.Net) - 一个最大限度支持邮件客户端的C#库，可以把样式表嵌入到内置的style属性中。
* [StrongGrid](https://github.com/Jericho/StrongGrid) - 用于 SendGrid v3 API 的客户端。不仅能发送邮件，还能批量导入联系人、管理列表与细分(segment)、给列表创建自定义属性等，还包含 SendGrid Webhooks 的解析器。

## 数学

* [MathNet](https://www.mathdotnet.com/) - Math.NET是一个开源项目，旨在创建和维护涵盖基础数学在内的工具集，面向高级和日常需要使用此类功能的.Net开发人员。
* [Microsoft Automatic Graph Layout](https://github.com/Microsoft/automatic-graph-layout) - 用于图表布局和查看的工具集。
* [UnitConversion](https://github.com/atulmish/UnitConversion) - 用于.NET Core 和 .NET Framework 的可扩展单位转换库。
* [ALGLIB](https://www.alglib.net/) - ALGLIB是一个跨平台的数值分析和数据处理库。支持多种编程语言(C++、C#、Delphi)和操作系统(Windows和POSIX，包括Linux) **[专利所有]** 和 **[免费版本]**
* [AutoDiff](https://github.com/alexshtf/autodiff) - AutoDiff 是一个用于快速计算由表达式定义的渐变函数的库，主要用于数值优化。
* [GeometRi](https://github.com/RiSearcher/GeometRi.CSharp) - .NET的简单及轻量级计算几何库。
* [Rationals](https://github.com/tompazourek/Rationals) - 具有任意精度的.NET有理数算法实现。
* [MKL.NET](https://github.com/AnthonyLloyd/MKL.NET) -用于 Intel MKL 的简单跨平台 .NET API。

## 媒体

* [CSCore](https://github.com/filoe/cscore) - 高级音，支持回放/录音、解码/编码和实时音频数据处理(有效，形象化...)。
* [TagLib#](https://github.com/mono/taglib-sharp) - TagLib#(即 taglib-sharp)是一个读写多媒体文件元数据的库，支持视频、音频和照片格式。
* [LibVLCSharp](https://github.com/videolan/libvlcsharp) - 用于libvlc的Xamarin绑定，VideoLAN制作的支持VLC应用的多媒体框架。
* [NAudio](https://github.com/naudio/NAudio) - 回放、解码、编码各种各样的音频文件格式，如MP3、MP4、WAV、AIFF、Speex等。
* [Xabe.FFmpeg](https://github.com/tomaszzmuda/Xabe.FFmpeg) - FFmpeg的.NET Standard封装。在不用知道FFmpeg是怎样工作的情况下就可以处理媒体文件，可以用于从C#应用中把自定义参数传递给FFmpeg。**[$]**

## 度量

* [C# StatsD Client](https://github.com/Pereingo/statsd-csharp-client) - Etsy's StatsD 服务器的C#客户端。
* [Foundatio](https://github.com/FoundatioFx/Foundatio#metrics) - 内存通用接口的Redis、StatsD、Metrics.NET实现。

## 微框架

* [.NET Micro Framework Interpreter](https://github.com/NETMF/netmf-interpreter) - Microsoft® .NET Micro Framework (NETMF) 是 Visual Studio 给小型设备提供编写嵌入式应用的框架。

## 缩率

* [Microsoft Ajax Minifier](https://archive.codeplex.com/?p=ajaxmin) - 包含JS和CSS压缩工具，有着很高的性能，专为.NET设计。可以选择是否生成JS代码的Source Maps。
* [Web Markup Minifier](https://github.com/Taritsyn/WebMarkupMin) - 包含标记语言缩小器集的.NET库。该项目的目的就是通过减小HTML、XHTML和XML的代码量来改善web应用的性能。
* [CompressedStaticFiles](https://github.com/AnderssonPeter/CompressedStaticFiles) - 把压缩过的静态文件发送给浏览器而不用压缩命令，当浏览器声明支持时还可以发送更高级的图片格式。

## 杂项
* [CSharp Pad](http://csharppad.com) - 有着非常不错的代码完成度的基于C#的REPL。
* [AzureCrawler](https://github.com/yagopv/AzureCrawler) - 从 Angular、Ember、Durandal 或任何JavaScript应用中获取HTML快照。
* [CSScript](https://www.cs-script.net/) - CS-Script是一个基于CLR的脚本系统，使用C#作为编程语言。CS-Script目前针对微软的CLR实现（.NET 2.0/3.0/3.5/4.0/4.5）并完整支持Mono。附带很多附加特性，比如脚本宿主。
* [CsvHelper](https://github.com/JoshClose/CsvHelper) - 帮助读写CSV文件的开发库。https://github.com/JoshClose/CsvHelper
* [Hashids.net](https://github.com/ullmark/hashids.net) - 按照https://hashids.org，从整型变量中生成唯一的短整型id。 
* [ConsoleTableExt](https://github.com/minhhungit/ConsoleTableExt) - .Net控制台应用生成表格的库。
* [FlatMapper](https://github.com/joaomatossilva/FlatMapper) - 以兼容LINQ的方式在纯文本文件间导入和导出数据的库。
* [FluentValidation](https://github.com/FluentValidation/FluentValidation) - 一个小型的.NET校验库，使用流式接口和lambda表达式构建校验规则。
* [FormHelper](https://github.com/SinanBozkus/FormHelper) - ASP.NET Core 表格与验证帮助器。表格帮助器可以创建ajax表格并验证是否输入了任何javascript代码。（兼容流式验证）
* [Guard](https://github.com/safakgur/guard) - 高性能、可扩展的参数验证库。
* [Valit](https://github.com/valit-stack/Valit) - Valit是用于.NET的非常简单的流式验证。
* [Humanizer](https://github.com/Humanizr/Humanizer) - Humanizer能够在.NET平台上满足所有针对字符串、枚举、日期、时间、时间范围、数字等类型数据的操作和显示要求。
* [LINQPad](https://www.linqpad.net) - C#/VB/F#的便签本，能够立即执行任何表达式、语句块或程序，带有富文本显示等有用的特性。同样可以让你使用LINQ进行交互性数据库查询。[$]
* [Polly](https://github.com/App-vNext/Polly) - 表达诸如Retry、Wait-and-Retry、Circuit Breaker 和 Bulkhead Isolation的瞬时异常处理和恢复策略，线程安全且支持异步(4.0 / 4.5 / .NET Core / .NET Standard / Xamarin)。
* [Rant](https://github.com/TheBerkin/rant3) - Rant Procedural Text 生成 DSL。
* [ScriptCS](https://github.com/scriptcs/scriptcs) - 使用文本编辑器、NuGet和强大的Roslyn来开发C#应用。
* [Shielded](https://github.com/jbakic/Shielded) - .NET的 Software Transactional Memory (STM) 实现。
* [MSBuild ILMerge task](https://archive.codeplex.com/?p=ilmergemsbuild) - MSBuild ILMerge task 是一个NuGet包，在自动构建 Visual Studio 项目的时候可以使用有名的ILMerge工具。
* [ReactJS.NET](https://github.com/reactjs/React.NET) - ReactJS.NET是一个在C#中单独使用Babel和Facebook的React和JSX更容易的库。
* [Aeron.NET](https://github.com/AdaptiveConsulting/Aeron.NET) - 可靠有效的UDP单点广播、UDP多点广播和IPC消息发送——Aeron的.NET版。
* [TypeShape](https://github.com/eiriktsarpalis/TypeShape) - TypeShape是一个用于实践性通用编程的小型、可扩展F#库。
* [Streams](https://github.com/nessos/Streams) - 用于数据流上有效函数式管道的轻量级F#/C#库。
* [Warden](https://github.com/warden-stack/Warden) - 给应用、资源和基础设施定义“健康检查”，保持Warden实时被监控。
* [ByteSize](https://github.com/omar/ByteSize) - ByteSize是一个工具类，通过消除要表示值的歧义，可以更轻松的在代码中表示字节大小。ByteSize是字节，System.TimeSpan是时间。
* [Jot](https://github.com/anakic/jot) - 持久化与恢复应用状态的库。（.settinngs文件更好的替代）
* [Enums.NET](https://github.com/TylerBrinkley/Enums.NET) - Enums.NET 是一个高性能的类型安全的.NET枚举工具库。
* [HidLibrary](https://github.com/mikeobrien/HidLibrary) - 该库可以让你在.NET中使用可兼容的Hid对USB设备进行枚举和通信。
* [SystemWrapper](https://github.com/jozefizso/SystemWrapper) - SystemWrapper是一个更轻松的测试系统API的.NET库。
* [YoutubeExplode](https://github.com/Tyrrrz/YoutubeExplode) - 用于提取元数据和下载Youtube视频与播放列表的Ultimate库。
* [DeviceId](https://github.com/MatthewKing/DeviceId) - 生成一个“设备ID”用于唯一的鉴别一台计算机。
* [DeviceDetector.NET](https://github.com/totpero/DeviceDetector.NET) - 通用设备探测库可以解析任何用户客户端以及探测浏览器、操作系统、设备使用类型(桌面、写字板(tablet)、移动端、电视、汽车、控制台等)、商标和模型。
* [NaturalSort.Extension](https://github.com/tompazourek/NaturalSort.Extension) - StringComparer的扩展方法，增加了对自然排序的支持(例：用"abc1", "abc2", "abc10"替代"abc1", "abc10", "abc2").
* [Coravel](https://github.com/jamesmh/coravel) Near-zero配置.NET Core 库，轻轻松松的进行任务调度、缓存、队列、邮件、事件广播等。

## MVVM

* [Caliburn.Micro](https://github.com/Caliburn-Micro/Caliburn.Micro) - 小型但功能强大的框架，旨在所有XAML平台上创建应用。对MV*模式的强大支持可以让你快速构建解决方案，且不必牺牲代码质量和可测试性。
* [MVVM Light Toolkit](https://github.com/lbugnion/mvvmlight) - 该工具箱主要是用来加速创建和开发MVVM应用，适用于WPF、Silverlight、Windows Store（RT）和 Windows Phone 平台。
* [Catel](https://www.catelproject.com/) - Catel是一个应用开发平台，主要着眼于MVVM(WPF、Silverlight、Windows Phone 及 WinRT)和MVC(ASP.NET MVC)。Catel的核心部分包含IoC容器、模型、校验、备忘录模式(memento)、消息中介(message mediator)、参数检查等。
* [UpdateControls](https://updatecontrols.net/cs/) - Update Controls 不需要实现`INotifyPropertyChanged`或声明一个`DependencyProperty`，可以将控件直接关联到CLR属性，完美贴合 Model/View/ViewModel模式。
* [ReactiveUI](https://github.com/reactiveui/reactiveui/) - 一个.NET下的MVVM框架，集成了反应式(Rx)扩展框架，允许开发者使用 WPF、Windows Store Apps、WP8 或 Xamarin 创建优雅的、可测试的应用。
* [Okra App Framework](https://okraframework.github.io) - 一个以app为中心的 Windows 8.1 MVVM 框架，融合依赖注入，包含一套完整的 Visual Studio MVVM 模板。
* [Prism](https://github.com/PrismLibrary/Prism) - 跨平台桌面与移动端MVVM开发框架。
* [Win Application Framework (WAF)](https://github.com/jbe2277/waf) - 一个轻量级的框架，能够帮助你创建有着不错结构的WPF和UWP应用。支持使用分层架构和MVVM模式。
* [MVVMCross](https://github.com/MvvmCross/MvvmCross) - 跨平台mvvm移动开发框架，针对WP7和WP8的WPF/Silverlight、Android的Mono、iOS的MonoTouch、Windows通用项目(WPA8.1 和 Windows 8.1 应用商店app). 它使用可移植类库(PCL)来支持可维护的跨平台C#原生应用。
* [Stylet](https://github.com/canton7/stylet/) - 最小化MVVM框架（参考 Caliburn Micro），包含了良好的文档、高覆盖率的测试以及自带的IoC容器。
* [Gemini](https://github.com/tgjones/gemini) - 类似 Visual Studio Shell 的IDE框架。基于WPF、AvalonDock和Caliburn Micro构建。
* [Toms Toolbox](https://github.com/tom-englert/TomsToolbox) - Visual Composition 框架用于在[Managed Extensibility Framework (MEF)](https://docs.microsoft.com/en-us/dotnet/framework/mef/)的基础上轻松构建模块化的MVVM应用.
* [MVVM Dialogs](https://github.com/FantasticFiasco/mvvm-dialogs) - 当在WPF或UWP中使用MVVM时，框架简化了从视图模型中打开对话框的概念。
* [Smaragd](https://github.com/nkristek/Smaragd) - 使用MVVM结构来开发.NET应用的依赖于平台的轻量级库。

## 对象到对象映射

* [AutoMapper](https://github.com/AutoMapper/AutoMapper) - .NET中基于惯例的对象到对象映射器。https://automapper.org
* [TinyMapper](https://github.com/TinyMapper/TinyMapper) - 用于.NET的小型快速对象映射器。
* [ExpressMapper](https://github.com/fluentsprings/ExpressMapper) - 轻量级、快速的.NET映射器，自动且简单的把一类对象映射到另一类。ExpressMapper完全依赖于表达式树。
* [AgileMapper](https://github.com/agileobjects/AgileMapper) - 支持 .NET Standard 1.0 的零配置对象映射器。
* [Mapster](https://github.com/MapsterMapper/Mapster) - .net中高性能的对象映射器。

## Office

* [ExcelDna](https://github.com/Excel-DNA/ExcelDna) - ExcelDna使用C#、F#或VB .NET让 Excel Add-Ins 的创建和部署更轻松。
* [ClosedXML](https://github.com/ClosedXML/ClosedXML) - ClosedXML让开发人员更便捷地创建 Excel 2007、2010 文件。
* [NPOI](https://github.com/tonyqus/npoi) - .NET版的POI项目，原Java版于。https://poi.apache.org/
* [EPPlus](https://github.com/JanKallman/EPPlus) - EPPlus是一个.NET库，用于读写 Open Office Xml 格式的 Excel 2007、2010 文件(xlsx)。
* [Open XML SDK](https://github.com/officedev/open-xml-sdk) - 用于处理 Open XML 文档(包括DOCX、XLSX和PPTX)的开源库。
* [DocX](https://github.com/xceedsoftware/DocX) - DocX是一个.NET库，开发人员可以用它操作 Word 2007/2010/2013 文档，而不需要提前安装 Microsoft Word 或 Office。
* [ExcelDataReader](https://github.com/ExcelDataReader/ExcelDataReader) - C#开发的用于读 Microsoft Excel 文档(2.0-2007)的快速且轻量级库。
* [NetOffice](https://github.com/NetOfficeFw/NetOffice) - 用于 Microsoft Office 应用的.NET包装器程序集。
* [GemBox.Bundle](https://www.gemboxsoftware.com/bundle) - .NET组件的包，使office文档(Excel、Word、PowerPoint、PDF和邮件)的处理变得快速、简单、有效。**[$][简装版免费]**
* [Outlook Redemption](http://www.dimastr.com/redemption/home.htm) - 配合 Outlook Object Model 和 (Extended) MAPI 使用的库，支持 Outlook 98 - 2019。在Exchange和Outlook中和对象/邮件/账号/目录一起使用。**[$]**

## ORM

* [Entity Framework 6](https://github.com/dotnet/ef6) - 对象关系型映射器，让.NET开发人员使用领域特定的对象来处理关系型数据。
* [Entity Framework Core](https://github.com/dotnet/efcore) - 对象关系型映射器，让.NET开发人员使用领域特定的对象来处理关系型数据。
* [EntityFramework.Exceptions](https://github.com/Giorgi/EntityFramework.Exceptions) - 对 Entity Framework Core 使用类型的Exceptions，当你的SQL查询违反了SqlServer、MySql、PostgreSQL或SQLite中的数据库约束。
* [Dapper](https://github.com/StackExchange/Dapper) - [StackExchange](https://stackexchange.github.io/)提供的一个简单的对象映射器。
* [Dapper Extensions](https://github.com/tmsmith/Dapper-Extensions) - 一个小型库，它为你的POCO补充了Dapper，通过添加基本的CRUD操作(Get, Insert, Update, Delete)。
* [Dapper.FastCRUD](https://github.com/MoonStorm/Dapper.FastCRUD) - Dapper的最快微ORM扩展。
* [FreeSql](https:/githun.com/dotnetcore/FreeSql) - dotnet便捷的ORM，支持MySql、SqlServer、PostgreSQL、Oracle、Sqlite、Firebird、达梦、人大金仓、神舟通用、翰高和Access。
* [NHibernate](https://github.com/nhibernate) - NHibernate对象关系映射器。
* [Fluent NHibernate](https://github.com/nhibernate/fluent-nhibernate) - 便捷、无需使用 XML、安全编译、自动化、基于约定命名的NHibernate映射库。
* [FluentMigrator](https://github.com/fluentmigrator/fluentmigrator) - 用于.net的便捷的迁移框架。
* [ServiceStack.OrmLite](https://github.com/ServiceStack/ServiceStack.OrmLite) - 轻量、简单、快速、基于命名约定的 POCO ORM。**[[对开源软件免费](https://github.com/ServiceStack/ServiceStack.OrmLite/blob/master/license.txt)]** **[$]**
* [Massive](https://github.com/FransBouma/Massive) - 永远爱你的小型、令人愉悦的数据访问工具。
* [LINQ to DB](https://github.com/linq2db/linq2db) - 最快的 LINQ 数据库访问库，简单、轻量、快速、类型安全，在你的POCO对象和数据库之间建起一座桥梁。
* [MicroLite ORM](https://github.com/MicroLite-ORM/MicroLite) MicroLite ORM 是一个用于.NET framework的微型对象关系映射器，旨在易于使用、可扩展以及可测试。
* [PetaPoco](https://github.com/CollaboratingPlatypus/PetaPoco) - POCO的微型ORM-ish。
* [AsyncPoco](https://github.com/tmenier/AsyncPoco) - 完全异步的长等待的PetaPoco分支。
* [NPoco](https://github.com/schotime/NPoco) - 基于PetaPoco的Schotime分支，把一个查询的结果映射到PCOCO对象的简单microORM。
* [Limebean](https://github.com/Nick-Lucas/LimeBean) - 混合ORM，使用SQL代码段，并且不需要模型类。
* [LLBLGen Pro](https://www.llblgen.com) - Entity Framework 的实体建模解决方案，NHibernate、LINQ到SQL、及其自身的ORM框架：LLBLGen Pro Runtime Framework. **[$][精简版免费]**
* [Insight.Database](https://github.com/jonwagner/Insight.Database) - Insight.Database 是.NET的快速且轻量级的micro-ORM。
* [DbExtensions](https://maxtoroq.github.io/DbExtensions/) - 非常关注查询结构、颗粒度和代码美感的数据获取框架。
* [SmartSql](https://github.com/dotnetcore/SmartSql) - SmartSql = MyBatis + Cache（Memory | Redis）+ ZooKeeper + R / W Splitting + Dynamic Repository ....
* [RepoDb](https://github.com/mikependon/RepoDb) - .NET的混合ORM库。
* [Venflow](https://github.com/TwentyFourMinutes/Venflow) - PostgreSQL超快的轻量级ORM。

## 包管理

* [NuGet](https://www.nuget.org/) - .NET 包管理器。
* [BaGet](https://github.com/loic-sharma/BaGet/) - 轻量级跨平台的NuGet和Symbol服务器。
* [Cloudsmith](https://cloudsmith.com/nuget-feed/) - 完全管理的包管理器SaaS，支持NuGet、Npm、Docker等更多。**[Public/OSS免费]** **[$]**
* [MyGet](https://www.myget.org/) - 用于NuGet、NPM、Bower和VSIX的宿主包仓库，支持CI即服务。**[$]**
* [Paket](https://github.com/fsprojects/Paket) - .NET的一个包依赖管理器，支持NuGet包和GitHub仓库。https://fsprojects.github.io/Paket/
* [Sleet](https://github.com/emgarten/sleet/) - 支持 AWS S3 和 Azure Storage 的NuGet静态种子生成器。

## PDF

* [Cloudmersive PDF](https://cloudmersive.com/pdf-api) - Cloudmersive PDF 是一个本机 .NET Framework 和 .NET Core NuGet 库和API服务，可以大规模且高保真的创建、修改、加密或转换PDF文档 ，并且无限期免费使用。**[免费]**
* [Docotic.Pdf](https://bitmiracle.com/pdf-library/) - .NET 和 .NET Core 应用中创建、读、编辑、画以及打印PDF文档的PDF库。 100%可控且没有不安全的代码。**[$]** **[[开源软件免费](https://bitmiracle.com/pdf-library/free-pdf-library.aspx)]**
* [ITextSharp](https://github.com/itext/itextsharp) - iText是一个PDF库，用于创建、修改、检查和维护 Portable Document Format(PDF)格式的文档。**[$]** **[开源软件免费]**
* [PdfiumViewer](https://github.com/pvginkel/PdfiumViewer) - PdfiumViewer是一个基于PDFium项目的PDF查看器。
* [WkhtmlToPdf](https://github.com/codaxy/wkhtmltopdf) - 围绕wkhtmltopdf中的工具的C#包装器，可以使用HTML和CSS生成漂亮的PDF文件。
* [Pdfium.Net SDK](https://pdfium.patagames.com/) - 高级 C# PDF 库，用于渲染、创建、编辑、合并、拆分、打印以及查看PDF。开源的PDF查看器在[GitHub](https://github.com/patagames)上可获得。[NuGet package](https://www.nuget.org/packages/Pdfium.Net.SDK/)也可以轻松的用到你的项目中去。**[$]**

## 分析器

* [MiniProfiler](https://github.com/MiniProfiler/dotnet) - 一个简单但有效的小型分析器，用于ASP.NET网站。
* [Glimpse](https://github.com/glimpse/glimpse) - 开源web诊断平台。
* [Unchase.FluentPerformanceMeter](https://github.com/unchase/Unchase.FluentPerformanceMeter) - 开源且跨平台的 .Net Standard 2.0 库，旨在度量方法的性能。

## 协议

* [SSH.NET](https://github.com/sshnet/SSH.NET) - .NET上安全的Shell(SSH)库，进行了并行优化。提供SSH命令，SFTP/SCP上传和下载，以及SOCKS4/SOCKS5/HTTP代理。
* [FluentFTP](https://github.com/robinrodricks/FluentFTP) - 用于.NET的FTP和FTPS库，对速度进行了优化。提供大量的FTP命令，文件上传/下载和FTP代理。
* [SharpSnmpLib](https://docs.sharpsnmp.com/) - .NET/Mono/Xamarin的开源SNMP实现，支持版本有：1、2c和3。
* [DNS](https://github.com/kapetan/dns) - 解析与序列化DNS消息的库，包括基本的DNS客户端和服务端。
* [DnsClient.NET](https://github.com/MichaCo/DnsClient.NET) - 用于 .NET Framework DNS查找的简单但是强大、高性能的开源库。

## 推送通知

* [PushSharp](https://github.com/Redth/PushSharp) - 服务器端的推送通知库，支持iOS、OSX、Android、Chrome、Windows Phone、Windows 8、Backberry和Amazon设备。

## 查询构造器
* [SqlKata](https://sqlkata.com) - 优雅的SQL查询构造器，支持复杂查询、连接查询、子查询、复杂条件查询、供应商引擎目标(vendor engine targets)等。

## 队列

* [CAP](https://github.com/dotnetcore/CAP) - 用于RabbitMQ或KafkaAn的有着本地消息持久化功能的EventBus。
* [NServiceBus](https://github.com/Particular/NServiceBus) - .NET平台下最流行的服务总线。
* [Gofer.NET](https://github.com/brthor/Gofer.NET) - 简单的C# API，用于.NET Core的分布式后台Tasks/Jobs，灵感来自于python的celery。
* [Hangfire](https://github.com/HangfireIO/Hangfire) - 在ASP.NET应用内部执行一劳永逸，延迟和重复任务的极其简单的方法。
* [RabbitMQ.NET](https://github.com/rabbitmq/rabbitmq-dotnet-client) - AMQP客户端的C#实现，通过WCF绑定到已有的AMQP服务。
* [NetMQ](https://github.com/zeromq/netmq) - NetMQ是ZeroMQ纯C#移植版本。
* [MassTransit](https://github.com/MassTransit/MassTransit) - MassTransit是精简服务总线(lean service bus)的实现，使用 .NET Framework 来构建松耦合应用。
* [Rebus](https://github.com/rebus-org/Rebus) - Rebus是.NET上的精简服务总线，本质上与NServiceBus、MassTransit类似，只不过更加精简。
* [RestBus](https://github.com/tenor/RestBus) - RabbitMQ面向服务的.NET消息库。
* [RawRabbit](https://github.com/pardahlman/RawRabbit) - RabbitMQ的现代 .NET Core 库。
* [EasyNetQ](https://github.com/EasyNetQ/EasyNetQ) - 易于使用的 RabbitMQ .NET API。
* [Warewolf ESB](https://github.com/Warewolf-ESB/Warewolf) - 易于使用的服务总线和微服务平台，能够在可视化IDE中便捷的创建应用和服务。
* [Confluent's .NET Client](https://github.com/confluentinc/confluent-kafka-dotnet) - 用于 Apache Kafka 的 Confluent's .NET Client。
* [Foundatio](https://github.com/FoundatioFx/Foundatio#queues) - 内存、Redis和Azure实现的通用接口。
* [Kafunk](https://github.com/jet/kafunk) - 源自Jet的 F# Kafka 客户端。
* [Brighter](https://github.com/BrighterCommand/Brighter) - 命令分发器、处理器和分布式任务队列。https://www.goparamore.io/

## 反应式编程

* [Rx.NET](https://github.com/dotnet/reactive) - Reactive Extensions (Rx) 库使用观察者序列(observable sequences)和LINQ风格的查询操作，来进行异步和基于事件的程序开发。
* [Dynamic Data](https://github.com/reactivemarbles/DynamicData) - 用于集合的 Reactive Extensions (Rx).

## 实时通信

* [SIPSorcery](https://github.com/sipsorcery/sipsorcery) - 支持SIP、VoIP和WebRTCA的跨平台 C# .NET 库。

## 计划调度

* [FluentScheduler](https://github.com/fluentscheduler/FluentScheduler) - 在应用中自动化运行任务的有着便捷接口的任务调度器。
* [NCrontab](https://github.com/atifaziz/NCrontab) - 用于解析和格式化[crontab](http://crontab.org/)表达式的类库，以及基于设定时程表(crontab schedule)来计算发生的时间。
* [QuartzNet](https://github.com/quartznet/quartznet) - Quartz是.NET平台的企业级调度器。
* [Hangfire](https://github.com/HangfireIO) - 在ASP.NET应用内部执行一劳永逸，延迟和重复任务的极其简单的方法。
* [Chroniton](https://github.com/leosperry/Chroniton) - 简单、完全集成、可自定义的库，用于按计划进行强类型的任务。
* [DurableTask](https://github.com/Azure/durabletask) - 该框架允许用户在C#中使用async/await功能来开发长时间运行的持久性工作流。
* [Wexflow](https://github.com/aelassas/Wexflow) - 有着跨平台管理器和设计器的可扩展工作流引擎。
* [Workflow Core](https://github.com/danielgerlag/workflow-core) - 轻量级嵌入式工作流引擎。

## SDK和API客户端

* [AWS SDK](https://github.com/aws/aws-sdk-net) - 用于.NET的 AWS SDK 让.NET开发者可以便捷地操作 Amazon Web Services。
* [Azure PowerShell](https://github.com/Azure/azure-powershell) - 一组PowerShell命令行，让开发者和管理员开发、部署和管理 Microsoft Azure 应用。
* [Countly SDK for Windows](https://github.com/Countly/countly-sdk-windows/) - Windows SDK，用于产品和市场经理的统计分析和市场平台。
* [Octokit.NET](https://github.com/octokit/octokit.net) - .NET平台下的 GitHub API 客户端库。
* [Dropbox.NET](https://github.com/dropbox/dropbox-sdk-dotnet) - 官方的Dropbox API .NET SDK。
* [Getty Images API SDK](https://github.com/gettyimages/gettyimages-api_dotnet) - 用于 Getty Images 和 iStock APIs 的SDK。

## Search

* [Elasticsearch .NET](https://github.com/elastic/elasticsearch-net) - Elasticsearch.Net & NEST
* [PlainElastic.Net](https://github.com/Yegoroff/PlainElastic.Net) - 简单的 ElasticSearch .Net 客户端。
* [SolrNet](https://github.com/SolrNet/SolrNet) - .NET平台下的Solr客户端。
* [SolrExpress](https://github.com/solr-express/solr-express) - A simple and lightweight query .NET library for Solr, in a controlled, buildable and fail fast way
* [Lucene.net](https://lucenenet.apache.org/) - Lucene.Net是Lucene搜索引擎库的移植，使用C#开发的面向.NET运行时用户。

## 序列化

* [Ceras](https://github.com/rikimaru0345/Ceras) - Ceras是一个二进制序列化器，能把任何对象转换成字节数组并返回，在性能、速度和可用性上都有提升。支持引用循环，庞大/复杂的继承链，将对象拆分为多个部分等。
* [Protobuf.NET](https://github.com/protobuf-net/protobuf-net) - Protocol buffers 是Google使用的二进制序列化格式，在Google数据通讯中大量使用。
* [Json.NET](https://github.com/JamesNK/Newtonsoft.Json) - .NET平台下流行的、高性能JSON框架。
* [ServiceStack.Text](https://github.com/ServiceStack/ServiceStack.Text) - 在servicestack.net中使用的JSON、JSV、CSV文本序列化器。
* [Msgpack-Cli](https://github.com/msgpack/msgpack-cli) - CLI的MessagePack实现。
* [Jil](https://github.com/kevin-montrose/Jil) - 在Sigil(StackOverflow上使用)上构造的 .NET JSON 序列化器，
* [ProtoBuf](https://github.com/SilentOrbit/protobuf) - 根据.proto规范，为 protocol buffer 序列化内容生成C#代码。
* [F# Data](https://fsharp.github.io/FSharp.Data/) - F#类型提供程序，访问XML、JSON、CSV和HTML文件（基于样例文档），以及访问 WorldBank 数据。
* [Bond](https://github.com/Microsoft/bond) - 跨平台框架，用于处理系统化(schematized)数据。支持跨平台的序列化、反序列化，以及强大的通用机制来高效处理数据。
* [Hyperion](https://github.com/akkadotnet/Hyperion) - .NET framework 的高性能多态序列化器。
* [FileHelpers](https://github.com/MarcosMeli/FileHelpers) - 免费易用的.NET库，从文件、字符串、流的固定长度或定界记录(delimited records)中导入或导出数据.
* [FsPickler](https://github.com/mbraceproject/FsPickler) - .NET的快速多格式消息序列化器。
* [Migrant](https://github.com/antmicro/Migrant) - 可用于未装饰类的快速、灵活的序列化框架。
* [Utf8Json](https://github.com/neuecc/Utf8Json) - 用于C#(.NET、.NET Core、Unity和Xamarin)的快速且零分配(Zero Allocation)JSON序列化器，由于可以直接读写成UTF8的二进制数据，因此性能上得到提升。

## 短信和电话

* [Twilio-csharp](https://github.com/twilio/twilio-csharp) - 用于配合Twilio拨打/接听电话和发送/接收短信的C#/.NET库。

## 状态机

* [Stateless](https://github.com/dotnet-state-machine/stateless) - 直接使用.NET代码创建状态机和基于状态机的轻量级工作流。
* [Automatonymous](https://github.com/MassTransit/Automatonymous) - .Net平台的状态机库，可以编写便捷的API风格状态机。
* [Appccelerate - State Machine](https://www.appccelerate.com/statemachine.html) - 强大的状态机库，配置有便捷的API和异步/同步状态转换支持。
* [LiquidState](https://github.com/prasannavl/LiquidState) - 用于.NET的高效的异步/同步状态机。

## 静态网站生成

* [FsBlog](https://github.com/fsprojects/FsBlog/) - 使用F#的博客类静态网站生成。
* [Pretzel](https://github.com/Code52/pretzel) - .NET平台下的网站生成工具（包含后续的一些功能）。
* [Sandra.Snow](https://github.com/Sandra/Sandra.Snow) - 受Jekyll启发的.NET平台静态网站生成工具。
* [Wyam](https://wyam.io/) - 简单易用、高度模块化、拥有强大配置能力的静态内容生成工具。

## 强命名

* [Strong Namer](https://github.com/dsplaisted/strongnamer) - 自动添加强命名到引用的那些没有强命名的程序集，这样就可以使用强命名在项目中引用和使用没有强命名的程序集(以及NuGet包)。
* [.NET Assembly Strong-Name Signer](https://github.com/brutaldev/StrongNameSigner) - .NET程序集签署强命名的工具软件，包括那些你没有源码的程序集。

## 风格指南

* [C# Style Guide](https://stackoverflow.com/questions/4678178/style-guide-for-c) - StackOverflow上的C#风格指南Q&A。
* [C# Coding Conventions](https://docs.microsoft.com/en-us/dotnet/csharp/programming-guide/inside-a-program/coding-conventions) - 官方的 MSDN C# 代码开发规范。
* [C# Async Guidance](https://github.com/davidfowl/AspNetCoreDiagnosticScenarios/blob/master/AsyncGuidance.md) - .NET Core 存在问题的异步模式清单，解释了如何解决这些问题。

## 模板引擎

* [RazorEngine](https://github.com/Antaris/RazorEngine) - 基于微软Razor解析引擎的开源模板引擎。
* [RazorLight](https://github.com/toddams/RazorLight) - 支持 .NET Standard 2.0 的基于微软Razor解析引擎的开源模板引擎。
* [Nustache](https://github.com/jdiamond/Nustache) - 无逻辑模板的开源库。
* [Stubble](https://github.com/stubbleorg/stubble) - .NET中裁剪{{mustache}}模板，Nustache的后继。
* [DotLiquid](https://github.com/dotliquid/dotliquid) - Ruby Liquid 模板语言的C#移植版本。
* [Mustache Sharp](https://github.com/jehugaleahsa/mustache-sharp) - 用于.NET的mustache文本模板引擎的扩展。
* [Scriban](https://github.com/lunet-io/scriban) - 用于.NET的快速、强大、安全以及轻量级的文本模板语言及引擎。

## 测试

* [ArchUnitNET](https://github.com/TNG/ArchUnitNET) - 有着便捷API的简单库，用于检查C#代码的架构。
* [AutoFixture](https://github.com/AutoFixture/AutoFixture) - AutoFixture是一个用于.NET的开源框架，用于最小化单元测试中设置'Arrange'阶段。
* [BDDfy](https://github.com/TestStack/TestStack.BDDfy) - BDDfy是最简单的BDD框架，没有之一！
* [Bogus](https://github.com/bchavez/Bogus) - 用于C#的简单且完整的假数据生成器，基于著名的faker.js。
* [ExpressionToCode](https://github.com/EamonNerbonne/ExpressionToCode) - 在断言中使用简单的C#语法，包括错误消息中的表达式和子表达式值。
* [FakeItEasy](https://github.com/FakeItEasy/FakeItEasy) - .NET上简单的mock库。https://fakeiteasy.github.io
* [Fluent Assertions](https://github.com/fluentassertions/fluentassertions) - 一组.NET扩展方法，可以更自然地指定TDD或BDD风格测试的期望输出。
* [FluentAutomation](https://github.com/stirno/FluentAutomation) - UI自动化的简单API。
* [FsCheck](https://github.com/fscheck/FsCheck) - .NET上的随机测试(Random Testing)。
* [Fuchu](https://github.com/mausch/Fuchu) - F#的单元测试库，通过tests-as-values机制让DSL的创建变得容易。
* [Machine.Specifications](https://github.com/machine/machine.specifications) - Machine.Specifications (MSpec) 是一个上下文/规范框架，消除了语言的干扰，并简化了测试。
* [Moq](https://github.com/Moq/moq4) - .NET上最流行和友好的mock框架。
* [NBuilder](https://github.com/garethdown44/nbuilder) - 快速创建测试对象。
* [NCrunch](https://www.ncrunch.net/) - 用于 Visual Studio 的自动化集成和并发测试工具。**[$]**
* [NFluent](http://www.n-fluent.net) - NFluent是一个断言库，旨在使你的.NET TDD 表达式变得便捷。
* [NSubstitute](https://nsubstitute.github.io/) - 用于 .NET mock 框架的友好工具。
* [NUnit](https://github.com/nunit/nunit) - 所有.NET语言的单元测试框架。
* [Rhino Mocks](https://github.com/ayende/rhino-mocks) - .NET上的动态Mock框架。
* [Shouldly](https://github.com/shouldly/shouldly) - Shouldly是一个断言框架，主要功能是在断言失败时，给出简单明了并且友好的错误信息。
* [Snapshooter](https://github.com/SwissLife-OSS/snapshooter) - .NET Core 和 .NET Framework 的快照测试工具。
* [SpecFlow](https://github.com/SpecFlowOSS/SpecFlow) - 将业务需求绑定到.Net代码。
* [Stryker.NET](https://github.com/stryker-mutator/stryker-net) - .NET Core 项目的变异测试。
* [xBehave.net](https://github.com/xbehave/xbehave.net) - xUnit.net扩展，使用自然语言描述你的测试。[https://xbehave.github.io](https://xbehave.github.io)
* [xUnit.net](https://github.com/xunit/xunit) - 是一个.NET平台下免费、开源、专注社区的单元测试框架。
* [Canopy](https://github.com/lefthandedgoat/canopy) - Canopy 是一个免费开源的 F# web 自动化测试框架。
* [Expecto](https://github.com/haf/expecto) - 用于F#有着 tests as values 机制的平滑测试框架，包括单元测试、基于属性的测试、性能测试和压力测试
* [ReportPortal](https://reportportal.io) - AI赋能的自动化测试展板，捕获、集成和分析测试报告来检查已发布程序的健康。
* [Compare-Net-Objects](https://github.com/GregFinzer/Compare-Net-Objects) - 使用反射来深度对比两个.NET对象，显示两者的的区别。
* [Verify](https://github.com/VerifyTests/Verify) - 简单认可复杂模型与文档的验证工具。

## 工具

* [Downloader](https://github.com/bezzad/Downloader) - 快速可靠的分段下载器，具有针对.NET应用的异步进度事件。
* [Fiddler](https://www.telerik.com/fiddler) -  任何浏览器、系统或平台都可使用的免费web调试代理。
* [Open Live Writer](https://github.com/OpenLiveWriter/OpenLiveWriter) - Blog writer 集成了WordPress、Blogger等，Open Live Writer 使写、预览、发布博客变得更容易。
* [CodeHub](https://github.com/CodeHubApp/CodeHub) - 在任何IOS设备上浏览和维护GitHub仓库最好的方式是使用CodeHub。
* [ShareX](https://github.com/ShareX/ShareX) - ShareX是免费开源的程序，可以截取或记录屏幕上的任意区域，只需按一个键就可以分享。它还可以把图片、文本或其它类型文件上传到超过80个目的地。
* [Myrtille](https://github.com/cedrozor/myrtille) - 本地HTML4/5远程桌面协议客户端，用于.NET的C#开发的HTTP网关。
* [Opserver](https://github.com/Opserver/Opserver) - 栈交换(Stack Exchange)监控系统
* [CatLight](https://catlight.io) - 为TFS/Jenkins/Travis/Appveyor创建状态通知，基于 .NET Core 和 Electron的跨平台桌面应用。**[免费][专利所有]**
* [Mockaco](https://github.com/natenho/Mockaco/) - 可快速配置的 API mock 服务器，Roslyn脚本API支持的可以模拟HTTP响应，改变 ASP.NET Core 功能，内置假数据生成和C#脚本引擎。
* [Netling](https://github.com/hallatore/Netling) - 负载测试工具客户端，用于简单的web测试，CPU或内存占用少，速度快。
* [Papercut](https://github.com/ChangemakerStudios/Papercut-SMTP) - Papercut是一个开源(基于.NET)的可视化邮件测试工具，在本地SMTP服务器上运行的旨在接收和提醒测试邮件消息。
* [Visual Studio Uninstaller](https://github.com/Microsoft/VisualStudioUninstaller) - 卸载和清除 Visual Studio 的所有模块。
* [Fake JSON Server](https://github.com/ttu/dotnet-fake-json-server) - 假的 REST API 用于原型制作或作为CRUD后台。不需要定义类型，它使用动态类型，数据被存储在一个JSON文件中。具有认证、WebSocket提醒、长时间运行的异步操作、随机生成错误和延时，以及实验性的GraphQL支持。
* [posh-dotnet](https://github.com/bergmeister/posh-dotnet) - 用于[dotnet CLI](https://github.com/dotnet/cli)的 `PowerShell` tab 补全。
* [SmartCode](https://github.com/dotnetcore/SmartCode) - SmartCode = IDataSource -> IBuildTask -> IOutput => 构建一切！！！ (包括[**代码生成**])
* [NETworkManager](https://github.com/BornToBeRoot/NETworkManager) - 用于管理网络和解决网络故障的强大工具。
* [AnyStatus](https://www.anystat.us) - 监测CI/CD管道、服务器、网络、健康和度量的桌面通知应用。支持 Azure DevOps、Jenkins、TeamCity、AppVeyor等的任何状态。
* [OctoLinker](https://github.com/OctoLinker/OctoLinker) - 通过 `project.json`、`packages.config`、`*.props`、`*.targets`进行导航，以及用于GitHub有着OctoLinker浏览器扩展的C#/F#/VB.NET 项目文件有效处理。
* [YARP](https://github.com/microsoft/reverse-proxy) - YARP 是一个反向代理工具，用于在.NET中创建快速的代理服务器，使用了 ASP.NET 和 .NET 基础。

## 交易

* [Lean](https://github.com/QuantConnect/Lean) - Lean引擎是一个开源的，完全由C#托管代码编写的交易算法引擎，用于桌面和云端。https://www.quantconnect.com/lean/
* [StockSharp](https://github.com/StockSharp/StockSharp) - 交易和交易算法(algorithmic trading)的开源平台(用于股票市场、外汇市场、比特币和期权交易)。https://stocksharp.com

## UI自动化

* [Atata](https://github.com/atata-framework/atata) - 基于 Selenium WebDriver 的自动化web测试全功能框架。
* [Managed Windows API](http://mwinapi.sourceforge.net/) - 内省与自动化第三方Windows/VC++应用且无需其源码。
* [FlaUI](https://github.com/FlaUI/FlaUI) - FlaUI是一个.NET库，用于帮助Windows应用(Win32、WinForms、WPF、Store Apps...)进行自动化UI测试。
* [PuppeteerSharp](https://github.com/hardkoded/puppeteer-sharp) - Puppeteer Sharp 是 Node.JS Puppeteer API 的官方移植版。
* [PuppeteerSharp.Contrib](https://github.com/hlaueriksson/puppeteer-sharp-contrib) - 补充 Puppeteer Sharp，通过便捷的方式来开发可读以及健壮的浏览器测试。

## Visual Studio 插件

* [Web Essentials](https://github.com/madskristensen/WebEssentials2019) - Web Essentials 提供了许多web开发人员期盼多年的 Visual Studio 新功能扩展。
* [VsVIM](https://github.com/VsVim/VsVim) - Visual Studio 中的 VIM。
* [Nuget Package Manager](https://marketplace.visualstudio.com/items?itemName=NuGetTeam.NuGetPackageManager) - 微软开发平台（包括 .NET）的包管理器。
* [SideWaffle](https://github.com/ligershark/side-waffle) - Visual Studio 2012/2013/2015 中的一组项目模板集合，让web开发更加轻松。
* [Resharper](https://www.jetbrains.com/resharper/) - Visual Studio 开发人员生产力工具。**[$]**
* [Refactoring Essentials](http://vsrefactoringessentials.com/) - C#和VB.NET重构的开源扩展，包括代码最佳实践分析器。
* [CodeContracts](https://github.com/Microsoft/CodeContracts) - 用于.NET的CodeContracts工具源码。
* [Git Diff Margin](https://github.com/laurentkempe/GitDiffMargin) - 在 Visual Studio 滚动条区域实时显示当前文件在Git上的改动。
* [Productivity Power Tools](https://marketplace.visualstudio.com/items?itemName=VisualStudioPlatformTeam.ProductivityPowerTools) - 一组 Visual Studio 专业版（及更高版本）的扩展，用于提高开发人员的生产力。
* [VSColorOutput](https://marketplace.visualstudio.com/items?itemName=MikeWard-AnnArbor.VSColorOutput) - 用于构建、查找、调试输出窗口的彩色高亮，可以自定义匹配模式以及添加颜色。
* [CodeLineage](https://marketplace.visualstudio.com/items?itemName=HippoCampSoftwareLtd.CodeLineage) - 轻松的查看不同文件版本间的累计更改(支持svn、git、mercurial、perforce)。
* [OzCode](https://marketplace.visualstudio.com/items?itemName=CodeValueLtd.OzCode) - OzCode 是一个 Visual Studio 扩展，它通过检测和隔离bug以减少调试时间必并提高生产率。**[$]**
 * [Roslynator](https://github.com/JosefPihrt/Roslynator) - Roslyn支持的用于C#的超过500+的分析器、重构与修复工具集合。
 * [Unchase.Odata.Connectedservice](https://github.com/unchase/Unchase.Odata.Connectedservice) - Visual Studio 连接服务，用于 OData web 服务以在C#或VB中生成API客户端代码。
 * [Unchase.OpenAPI.Connectedservice](https://github.com/unchase/Unchase.OpenAPI.Connectedservice) - Visual Studio 2017/2019 扩展，配合[NSwag](https://github.com/RicoSuter/NSwag)可生成用于 OpenAPI web 服务的 C# (TypeScript) HttpClient (或C#控制器) 代码。

## Web浏览器

* [CefSharp](https://github.com/cefsharp/CefSharp/) - Chromium支持的HTML5、CSS3和JS web 浏览器，用于WinForms和WPF。

## Web框架

* [ASP.NET MVC](https://dotnet.microsoft.com/apps/aspnet) - ASP.NET是一个免费的web框架，用于创建优秀的web站点和应用程序。
* [Coalesce](https://coalesce.intellitect.com/) - Coalesce是一个 ASP.NET Core web 快速开发框架。
* [FubuMVC](https://github.com/DarthFubuMVC/fubumvc) - .NET前端控制器(front-controller)风格的MVC框架。
* [NancyFx](https://github.com/NancyFx/Nancy) - 在.Net和Mono上创建HTTP服务的一个轻量级、非正式的框架。
* [IISNode](https://github.com/tjanczuk/iisnode) - IIS中宿主NodeJS应用。
* [Suave.IO](https://suave.io/) - 会让你在提前完成F#项目开发时喜极而泣的框架/库/web服务器(一个用F#编写Web应用的框架和服务器端)。
* [DotVVM](https://github.com/riganti/dotvvm) - 有 OWIN 和 ASP.NET Core 支持的 MVVM 框架，用于那些不想写JavaScript的人，同时是 Visual Studio 2015 和 2017的免费扩展。
* [Giraffe](https://github.com/giraffe-fsharp/Giraffe) - 构建富web应用时的多功能 (F#) ASP.NET Core 微矿建。

## Web服务器

* [Kestrel](https://github.com/aspnet/KestrelHttpServer) -  用于 ASP.NET Core 的基于libuv的web服务器。
* [EmbedIO](https://github.com/unosquare/embedio) - 基于Mono编写的跨平台的Web服务器。
* [XSP](https://github.com/mono/xsp) - Mono中的ASP.NET宿主服务器，包含了Apache模块、FastCGI模块，可挂载到其它web服务器或以一个测试用的独立服务器存在(类似微软的Cassini项目)。

## WebSocket

* [Fleck](https://github.com/statianzo/Fleck) - Fleck是一个C#实现的WebSocket服务器，是Nugget项目的分支。
* [SignalR](https://github.com/SignalR/SignalR) - ASP.NET库，可以在web应用中非常简单地实时添加功能。
* [SuperSocket](https://github.com/kerryjiang/SuperSocket) - 一个轻量级、可扩展的socket应用框架。
* [Websocket-Sharp](https://github.com/sta/websocket-sharp) - WebSocket协议的C#实现，包含客户端和服务器端。
* [WebSocket4NET](https://archive.codeplex.com/?p=websocket4net) - .NET 2.0+、Xamarin、Mono、Silverlight、Windows Phone 以及WinRT下的WebSocket客户端。
* [Crossertech](https://crosser.io/) - 提供一组好工具用于在Microsoft.NET等平台上构建实时应用。**[$]**
* [WampSharp](https://github.com/Code-Sharp/WampSharp) - [The Web Application Messaging Protocol](https://wamp-proto.org/)的C#实现 - 一个用于提供远程过程调用(Remote Procedure Calls)和WebSocket发布/订阅的发信模式的协议。
* [NetGain](https://github.com/StackExchange/NetGain) - Stack Overflow 赋能的高性能WebSocket服务器库。
* [Websockets.PCL](https://github.com/NVentimiglia/Websockets.PCL) - WebSockets.PCL是一个便携式类库，由 profile 259, C# WebSocket 实现。
* [Websocket.Client](https://github.com/Marfusios/websocket-client) - 基于本地C#类ClientWebSocket的多平台包装器，内置重连接和错误处理。

## Windows服务

* [TopShelf](https://github.com/Topshelf/Topshelf) - 一个简单的服务宿主框架，可使用.NET构建Windows服务。

## WPF

* [Data Grid Extensions](https://github.com/tom-englert/DataGridExtensions) - WPF DataGrid 控件的模块化扩展, 提供了诸如过滤、额外的列事件、扩展的星形色谱(star-size)列行为等功能。
* [Extended WPF Toolkit™](https://github.com/xceedsoftware/wpftoolkit) - 一个用于创建WPF应用的丰富控件、组件和工具集合。
* [WPF](https://github.com/dotnet/wpf) - WPF 是 .NET Core UI 框架，用于构建Windows桌面应用。

## 解析器库

* [Sprache](https://github.com/sprache/Sprache) - 用于直接在C#代码中构造解析器的简单轻量级库。
* [Pidgin](https://github.com/benjamin-hodgson/Pidgin) - Stack Overflow上开发的用于C#的轻量级、快速、灵活的解析库。
* [FParsec](https://github.com/stephan-tolksdorf/fparsec) - 用于F#的解析器组合子库。
* [Superpower](https://github.com/datalust/superpower) - 有着高质量错误报告的C#解析器构造工具套件。
* [CSLY](https://github.com/b3b00/CSLY) - 轻量级嵌入式词法分析器/解析器生成器。

## 其他列表

* [.NET-libraries-that-make-your-life-easier](https://github.com/tallesl/net-libraries-that-make-your-life-easier) - 生活不易.NET易(开源库)。
* [awesome-LINQ](https://github.com/aloisdg/awesome-linq) - 一组精心挑选的超棒的LINQ类库、工具等。
* [awesome-analyzers](https://github.com/Cybermaxs/awesome-analyzers) - 一组精心挑选的.NET编译器平台("Roslyn")诊断分析器和代码修复。
* [C# Algorithms, Data Structures](https://github.com/aalhour/C-Sharp-Algorithms) - 算法与数据结构实现清单。
* [Awesome .NET Core](https://github.com/thangchung/awesome-dotnet-core) - 超棒的 .NET core 库、工具、框架和软件集合。
* [ASP.NET Core Library and Framework Support](https://github.com/jpsingleton/ANCLAFS) - ASP.NET Core 和 .NET Core 目前所支持 .NET 库和框架清单。
* [Awesome .NET Performance](https://github.com/adamsitnik/awesome-dot-net-performance) - 一组精心挑选的有关.NET性能的书、课程、实训、会议讲话、博客和那些鼓舞人心的开源贡献者清单。
* [awesome-ddd](https://github.com/heynickc/awesome-ddd) - 一组精心挑选的领域模型驱动设计(DDD)、命令查询责任分离(CQRS)、事件溯源和事件风暴资源清单。
* [Awesome Unity](https://github.com/RyanNielson/awesome-unity) - 社区自发整理的超棒Unity资产、项目和资源高质量集合。
* [Awesome Xamarin](https://github.com/XamSome/awesome-xamarin) - 有意思的库/工具集合，用于Xamarin移动项目。
* [Awesome Roslyn](https://github.com/ironcev/awesome-roslyn) - 一组精心挑选有关Roslyn的书、入门指南、开源项目、分析器、代码修复和重构清单。
* [.NET Open Source Developer Projects](https://github.com/Microsoft/dotnet/blob/master/dotnet-developer-projects.md) - 该社区所维护的.NET开源项目清单对于开发过程中的任何方面都是有用的。

# 资源

* [Discover .NET](https://discoverdot.net) - 超棒的.NET开源与社区资源。
* [NuGet Trends](https://nugettrends.com) - 检查NuGet包的使用情况极其趋势。
* [Weekly C# Digest](https://csharpdigest.net/) - 每周电子邮件通讯，包括.NET社区精选top 5的链接。
